﻿using System;
using System.Collections.Generic;
using System.Linq;
using SimulacniProstredi.Grafy;
using System.Drawing;
using System.Drawing.Drawing2D;
using SimulacniProstredi.Sceny;
using System.Text;

namespace SimulacniProstredi.Algoritmy
{
    class ADA
    {
        double StartingInflationFactor = 15;
        double InflationFactor;
        public bool Ended = false;
        public bool ADARestart = false;

        List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>> AllNodes, Open, Closed, Incons, Solution = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
        List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>> CurrentNodesList = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
        Vertex<VertexData_State_ADA, EdgeData_Heuristic> Start, Goal, SmallestState;
        Scene ThisScene;
        private bool IsInList(Vertex<VertexData_State_ADA, EdgeData_Heuristic> Vertex, List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>> Vertexes)
        {
            foreach (Vertex<VertexData_State_ADA, EdgeData_Heuristic> v in Vertexes)
            {
                if (Vertex.VertexData.Equals(v.VertexData)) { return true; }
            }
            return false;
        }
        private bool IsInEdgeList(Edge<VertexData_State_ADA, EdgeData_Heuristic> edge, List<Edge<VertexData_State_ADA, EdgeData_Heuristic>> Edges)
        {
            foreach (Edge<VertexData_State_ADA, EdgeData_Heuristic> e in Edges)
            {
                if (edge.Equals(e))
                { return true; }
            }
            return false;
        }

        static public int[] ToPriority(int inPriority1, int inPriority2)
        {
            int[] p = new int[2];
            p[0] = inPriority1;
            p[1] = inPriority2;
            return p;
        }
        void UpdateSetMembership(Vertex<VertexData_State_ADA, EdgeData_Heuristic> Vertex)
        {
            if (!IsInList(Vertex, CurrentNodesList)) CurrentNodesList.Add(Vertex);//mozna predelat do UpdateVertex
            if (Vertex.VertexData.Getv != Vertex.VertexData.Getg)
            {
            if(!IsInList(Vertex,Closed))
            {
                Key(Vertex);
                Open.Remove(Open.Find(delegate(Vertex<VertexData_State_ADA, EdgeData_Heuristic> v) { return v.VertexData.Equals(Vertex.VertexData); }));//mozna predela s ohledem na zasahy do fronty
                Open.Add(Vertex);
            }
            else if (!IsInList(Vertex, Incons))
            {
                Key(Vertex);
                Incons.Add(Vertex);
            }
            }
            else
            { 
            if(IsInList(Vertex,Open))
            {
                Open.Remove(Open.Find(delegate(Vertex<VertexData_State_ADA, EdgeData_Heuristic> v) { return v.VertexData.Equals(Vertex.VertexData); }));//mozna predela s ohledem na zasahy do fronty
            }
            else if(IsInList(Vertex,Incons))
            {
                Incons.Remove(Incons.Find(delegate(Vertex<VertexData_State_ADA, EdgeData_Heuristic> v) { return v.VertexData.Equals(Vertex.VertexData); }));//mozna predela s ohledem na zasahy do fronty
            }
            }
        }

        bool LessVector(int[] a, int[] b)
        {
            if ((a[0] < b[0]) | ((a[0] == b[0]) & (a[1] < b[1]))) return true;
            else return false;
        }
        void FindSmallestKey()
        {
            int[] MinimalCost = ToPriority(int.MaxValue, int.MaxValue);
            int i = 0;
            int idx = -1;
            foreach (Vertex<VertexData_State_ADA, EdgeData_Heuristic> Item in Open)
            {
                if (LessVector(Item.VertexData.GetKey, MinimalCost))
                {
                    MinimalCost = Item.VertexData.GetKey;
                    idx = i;
                }
                i += 1;
            }
            SmallestState = Open[idx];
        }
        void UpdateKey()
        {
            int[] MinimalCost = ToPriority(int.MaxValue, int.MaxValue);
            int i = 0;
            int idx = -1;
            foreach (Vertex<VertexData_State_ADA, EdgeData_Heuristic> Item in Open)
            {
                Key(Item);
                if (LessVector(Item.VertexData.GetKey, MinimalCost))
                {
                    MinimalCost = Item.VertexData.GetKey;
                    idx = i;
                }
                i += 1;
            }
            SmallestState = Open[idx];
        }

        void Key(Vertex<VertexData_State_ADA, EdgeData_Heuristic> inVertex)
        {
            if (inVertex.VertexData.Getv >= inVertex.VertexData.Getg)
            {
                inVertex.VertexData.SetKey = ToPriority(inVertex.VertexData.Getg + Convert.ToInt32(inVertex.VertexData.Geth * InflationFactor), inVertex.VertexData.Getg);
            }
            else 
            {
                inVertex.VertexData.SetKey = ToPriority(inVertex.VertexData.Getv + inVertex.VertexData.Geth, inVertex.VertexData.Getv);
            }
        }
        void KeySmazat(Vertex<VertexData_State_ADA, EdgeData_Heuristic> inVertex)
        {
            if (inVertex.VertexData.Getv >= inVertex.VertexData.Getg)
            {
                inVertex.VertexData.SetKey = ToPriority(inVertex.VertexData.Getg, inVertex.VertexData.Getg);
            }
            else
            {
                inVertex.VertexData.SetKey = ToPriority(inVertex.VertexData.Getv, inVertex.VertexData.Getv);
            }
        }

        void ComputePath()
        {
           int ComputeRuns = 0;
            while (LessVector(SmallestState.VertexData.GetKey,Goal.VertexData.GetKey)|(Goal.VertexData.Getv < Goal.VertexData.Getg))
            {
                ComputeRuns = ComputeRuns + 1;
                Open.Remove(SmallestState);
                if (SmallestState.VertexData.Getv > SmallestState.VertexData.Getg)
                {
                    SmallestState.VertexData.Setv = SmallestState.VertexData.Getg;
                    Closed.Add(SmallestState);
            
                    ManageSuccesors(SmallestState);
                    foreach (Edge<VertexData_State_ADA, EdgeData_Heuristic> e in SmallestState.GetOutputEdges)
                    {
                        if (!(SmallestState.VertexData.Geth <= (e.GetIntoVertex.VertexData.Geth+1)))
                        {
                        }
                        if (e.GetIntoVertex.VertexData.Getg > (e.EdgeData.GetCost + SmallestState.VertexData.Getg))
                        {
                            e.GetIntoVertex.VertexData.SetBp = SmallestState;
                            e.GetIntoVertex.VertexData.Setg = (e.EdgeData.GetCost + SmallestState.VertexData.Getg);
                            UpdateSetMembership(e.GetIntoVertex);
                        }
                    }
                }
                else
                {
                    SmallestState.VertexData.Setv = int.MaxValue / 3 ;
                  
                    ManageSuccesors(SmallestState);
                    UpdateSetMembership(SmallestState);
                    foreach (Edge<VertexData_State_ADA, EdgeData_Heuristic> e in SmallestState.GetOutputEdges)
                    {
                        if (!(SmallestState.VertexData.Geth <= (e.GetIntoVertex.VertexData.Geth + 1)))
                        {
                        }
                        if (e.GetIntoVertex.VertexData.GetBp != null)
                        {
                            if (e.GetIntoVertex.VertexData.GetBp.VertexData.Equals(SmallestState.VertexData))
                            {
                                int minPred = e.GetIntoVertex.GetInputEdges[0].GetOutVertex.VertexData.Getv + e.GetIntoVertex.GetInputEdges[0].EdgeData.GetCost;
                                int minEdgeNumber = 0;
                                for (int i = 1; i < e.GetIntoVertex.GetInputEdges.Count(); i++)
                                {
                                    if ((e.GetIntoVertex.GetInputEdges[i].GetOutVertex.VertexData.Getv + e.GetIntoVertex.GetInputEdges[i].EdgeData.GetCost) < minPred) { minPred = e.GetIntoVertex.GetInputEdges[i].GetOutVertex.VertexData.Getv + e.GetIntoVertex.GetInputEdges[i].EdgeData.GetCost; minEdgeNumber = i; }
                                }

                                e.GetIntoVertex.VertexData.SetBp = e.GetIntoVertex.GetInputEdges[minEdgeNumber].GetOutVertex;
                                e.GetIntoVertex.VertexData.Setg = e.GetIntoVertex.VertexData.GetBp.VertexData.Getv + e.GetIntoVertex.GetInputEdges[minEdgeNumber].EdgeData.GetCost;
                                UpdateSetMembership(e.GetIntoVertex);
                            }
                        }
                    }

                }
               FindSmallestKey();
            }
        }
           public ADA(Scene InScene) 
        {
            AllNodes=new List<Vertex<VertexData_State_ADA,EdgeData_Heuristic>> ();
            ThisScene = InScene;
            Point instart = ThisScene.DetectPoint(ThisScene.Start);
            Point ingoal = ThisScene.DetectPoint(ThisScene.Goal);

            Goal = new Vertex<VertexData_State_ADA, EdgeData_Heuristic>(new VertexData_State_ADA(ingoal.X, ingoal.Y, new VertexData_State_ADA(ingoal.X, ingoal.Y)));
            Start = new Vertex<VertexData_State_ADA, EdgeData_Heuristic>(new VertexData_State_ADA(instart.X, instart.Y,Goal.VertexData));
        }
        void ManageSuccesors(Vertex<VertexData_State_ADA, EdgeData_Heuristic> Vertex)
        {
            if (Vertex.GetOutputEdges.Count() == 0)
            {
                List<VertexData_State_ADA> ListNewDataVertexex = Vertex.VertexData.Expand();

                foreach (VertexData_State_ADA v in ListNewDataVertexex)
                {

                    if ((v.X < (ThisScene.MaxMapSize.X)) & (v.Y < (ThisScene.MaxMapSize.Y)) & (v.X > 0) & (v.Y > 0))
                    {
                        Vertex<VertexData_State_ADA, EdgeData_Heuristic> Unit = new Vertex<VertexData_State_ADA, EdgeData_Heuristic>(v);
                        Vertex<VertexData_State_ADA, EdgeData_Heuristic> UnitAlredyInList = AllNodes.Find(delegate(Vertex<VertexData_State_ADA, EdgeData_Heuristic> AlreadyExpanded) { return AlreadyExpanded.VertexData.Equals(v); });
                        if (ThisScene.IsWalkable(Vertex.VertexData.X, Vertex.VertexData.Y, v.X, v.Y))
                        {

                            if (UnitAlredyInList != null)
                            {
                                Boolean FoundIt = false;
                                foreach (Edge<VertexData_State_ADA, EdgeData_Heuristic> e in UnitAlredyInList.GetInputEdges)
                                {
                                    if (e.GetOutVertex.VertexData.Equals(Vertex.VertexData)) FoundIt = true;
                                }
                                if (!FoundIt) { UnitAlredyInList.ConnectVertex(Vertex, new EdgeData_Heuristic(1), false); }
                            }
                            else
                            {
                                Unit.ConnectVertex(Vertex, new EdgeData_Heuristic(1), false);
                            
                                if (Unit.VertexData.Equals(Goal.VertexData))
                                { Goal = Unit; }

                                AllNodes.Add(Unit);
                            }

                        }
                        else
                        {
                            if (UnitAlredyInList != null)
                            {
                                Boolean FoundIt = false;
                                foreach (Edge<VertexData_State_ADA, EdgeData_Heuristic> e in UnitAlredyInList.GetInputEdges)
                                {
                                    if (e.GetOutVertex.VertexData.Equals(Vertex.VertexData)) FoundIt = true;
                                }
                                if (!FoundIt) { UnitAlredyInList.ConnectVertex(Vertex, new EdgeData_Heuristic(int.MaxValue / 2), false);
                                               
                                                }
                            }
                            else
                            {
                                Unit.ConnectVertex(Vertex, new EdgeData_Heuristic(int.MaxValue / 2), false);
                                AllNodes.Add(Unit);
                                 
                            }
                        }
                    }
                }
            }
        }

        void DecreaseInflationFactor()
        {
            if (Incons.Count() > 0)
            {
                double MinimalCost = Double.MaxValue;
                int i = 0;
                int idx = -1;
                foreach (Vertex<VertexData_State_ADA, EdgeData_Heuristic> Item in Incons)
                {
                    if ((Item.VertexData.Getg + Item.VertexData.Geth) < MinimalCost)
                    {
                        MinimalCost = Item.VertexData.Getg + Item.VertexData.Geth;
                        idx = i;
                    }
                    i += 1;
                }
                Vertex<VertexData_State_ADA, EdgeData_Heuristic> SmallestStateIncons = Incons[idx];
                if ((SmallestState.VertexData.Getg + SmallestState.VertexData.Geth) < (SmallestStateIncons.VertexData.Geth + SmallestStateIncons.VertexData.Getg))
                {
                    InflationFactor = Math.Min(InflationFactor, Goal.VertexData.Getg / (SmallestState.VertexData.Getg + SmallestState.VertexData.Geth));
                }
                else
                {
                    InflationFactor = Math.Min(InflationFactor, Goal.VertexData.Getg / (SmallestStateIncons.VertexData.Geth + SmallestStateIncons.VertexData.Getg));
                }
            }
            else 
            {
                    InflationFactor = Math.Min(InflationFactor, Goal.VertexData.Getg / (SmallestState.VertexData.Getg + SmallestState.VertexData.Geth));
            }
        }

        public void UseADA_FirstTime()
        {
            Start.VertexData.Setg = 0;
            InflationFactor = StartingInflationFactor;
            Open = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            Closed = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            Incons = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            Key(Goal);
            Key(Start);
            Open.Add(Start);
            FindSmallestKey();
           ComputePath();
            Solution.Add(Goal);
           ReconstructPath();

        }

        void restart()
        {
            Goal = new Vertex<VertexData_State_ADA,EdgeData_Heuristic> (new VertexData_State_ADA (Goal.VertexData.X,Goal.VertexData.Y, new VertexData_State_ADA(Goal.VertexData.X,Goal.VertexData.Y)));
            Start = new Vertex<VertexData_State_ADA, EdgeData_Heuristic>(new VertexData_State_ADA(Start.VertexData.X, Start.VertexData.Y,Goal.VertexData));
            Start.VertexData.Setg = 0;
            InflationFactor = StartingInflationFactor;
            AllNodes = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            CurrentNodesList = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            SmallestState = null ;
            Open = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            Closed = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            Incons = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            Solution = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
            Key(Goal);
            Key(Start);
            Open.Add(Start);
            FindSmallestKey();
            
                        ComputePath();

            Solution.Add(Goal);
           ReconstructPath();
           ADARestart = true;
           
        }

        public void UseADA()
        {
             
            if (InflationFactor == 1)
            {
                
            CheckEdge();
        

                  List<Edge<VertexData_State_ADA, EdgeData_Heuristic>> ListOfRemovedEdges = CheckEdgeForRemovedEdges();
                  ListOfRemovedEdges.ForEach(delegate(Edge<VertexData_State_ADA, EdgeData_Heuristic> e)
                  {
                      e.EdgeData.SetCost = 1;
                  });
                
                  ListOfRemovedEdges.ForEach(delegate(Edge<VertexData_State_ADA, EdgeData_Heuristic> e)
                {
                    
                    if ((!e.GetIntoVertex.Equals(Start.VertexData)))
                    {
                        int minPred = e.GetIntoVertex.GetInputEdges[0].GetOutVertex.VertexData.Getv + e.GetIntoVertex.GetInputEdges[0].EdgeData.GetCost;
                        int minEdgeNumber = 0;
                        for (int i = 1; i < e.GetIntoVertex.GetInputEdges.Count(); i++)
                        {
                            if ((e.GetIntoVertex.GetInputEdges[i].GetOutVertex.VertexData.Getv + e.GetIntoVertex.GetInputEdges[i].EdgeData.GetCost) < minPred) { minPred = e.GetIntoVertex.GetInputEdges[i].GetOutVertex.VertexData.Getv + e.GetIntoVertex.GetInputEdges[i].EdgeData.GetCost; minEdgeNumber = i; }
                        }

                        e.GetIntoVertex.VertexData.SetBp = e.GetIntoVertex.GetInputEdges[minEdgeNumber].GetOutVertex;
                        e.GetIntoVertex.VertexData.Setg = e.GetIntoVertex.VertexData.GetBp.VertexData.Getv + e.GetIntoVertex.GetInputEdges[minEdgeNumber].EdgeData.GetCost;
    
                        Key(e.GetIntoVertex);
 
                    }
                });

                  ListOfRemovedEdges.ForEach(delegate(Edge<VertexData_State_ADA, EdgeData_Heuristic> e)
                {
                    UpdateSetMembership(e.GetIntoVertex);
                  
                  
                });
                  if (ListOfRemovedEdges.Count() > 0) 
                { InflationFactor = StartingInflationFactor;
                Goal.VertexData.Setg = int.MaxValue / 3;
                Goal.VertexData.Setv = int.MaxValue / 3;

                Key(Goal);
               UpdateKey();

                ComputePath();

                }
                else Ended = true;
            }
            else if (InflationFactor > 1)
            {
                DecreaseInflationFactor();
                Incons.ForEach(delegate(Vertex<VertexData_State_ADA, EdgeData_Heuristic> v) { Open.Add(v); });
                Incons.Clear();
                UpdateKey();
                Closed.Clear();
                ComputePath();
                Solution = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
                Solution.Add(Goal);
                ReconstructPath();
               
            }

        }
       void CheckEdge()
        {
            bool FoundSolution = false;
            AllNodes.ForEach(delegate(Vertex<VertexData_State_ADA, EdgeData_Heuristic> v)
            {
                if (FoundSolution == true) return ;

                foreach (Edge<VertexData_State_ADA, EdgeData_Heuristic> e in v.GetOutputEdges)
                {

                    if (!ThisScene.IsWalkable(e.GetOutVertex.VertexData.X, e.GetOutVertex.VertexData.Y, e.GetIntoVertex.VertexData.X, e.GetIntoVertex.VertexData.Y))
                    {
                        if (e.EdgeData.GetCost < (int.MaxValue / 2))
                        {
                            restart();
                            FoundSolution = true;
                            return;
                        }
                    }
                }
            });
           
        }

       List<Edge<VertexData_State_ADA, EdgeData_Heuristic>> CheckEdgeForRemovedEdges()
       {

           //davat do seznamu hrabny, ktere jsou nove pruchozi
           List<Edge<VertexData_State_ADA, EdgeData_Heuristic>> ListOfEdges = new List<Edge<VertexData_State_ADA, EdgeData_Heuristic>>();

           AllNodes.ForEach(delegate(Vertex<VertexData_State_ADA, EdgeData_Heuristic> v)
           {
               //  foreach (Edge<VertexData_State_ADA, EdgeData_Heuristic> e in v.GetInputEdges)
               foreach (Edge<VertexData_State_ADA, EdgeData_Heuristic> e in v.GetOutputEdges)
               {

                   if (e.EdgeData.GetCost == (int.MaxValue / 2))
                   {
                        if (ThisScene.IsWalkable(e.GetOutVertex.VertexData.X, e.GetOutVertex.VertexData.Y, e.GetIntoVertex.VertexData.X, e.GetIntoVertex.VertexData.Y))
                        {
                       
                           if (!IsInEdgeList(e, ListOfEdges)) ListOfEdges.Add(e);
                       }
                   }
               }
           });
           return ListOfEdges;
       } 


        void ReconstructPath()
        {
            if (Solution == null) { return; }
            
            Vertex<VertexData_State_ADA, EdgeData_Heuristic> Path = Solution[0];

          while (Path.GetInputEdges.Count != 0)
   
            {
                int minPred = int.MaxValue;
                int minEdgeNumber = 0;
                bool found = false;
                for (int i = 0; i < Path.GetInputEdges.Count(); i++)
                {
                    if ((Path.GetInputEdges[i].GetOutVertex.VertexData.Getv + Path.GetInputEdges[i].EdgeData.GetCost < minPred) & (Path.GetInputEdges[i].EdgeData.GetCost != (int.MaxValue / 2)) & (!IsInList(Path.GetInputEdges[i].GetOutVertex, Solution))) { minPred = Path.GetInputEdges[i].GetOutVertex.VertexData.Getv + Path.GetInputEdges[i].EdgeData.GetCost; minEdgeNumber = i; found = true; }


                }
                if (found == false)
                {
                    break;
                }

                Solution.Insert(0, Path);
             Path = Path.GetInputEdges[minEdgeNumber].GetOutVertex;
            }
        }
        public List<Point> ReturnPoints()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_ADA, EdgeData_Heuristic> v in Solution)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }
        public List<Point> ReturnSearchedNodes()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_ADA, EdgeData_Heuristic> v in AllNodes)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }
        public List<Point> ReturnNewlySearchedNodes()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_ADA, EdgeData_Heuristic> v in CurrentNodesList)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }

        public void ClearCurrentNodesList()
        {
            CurrentNodesList = new List<Vertex<VertexData_State_ADA, EdgeData_Heuristic>>();
        }

    }
}
