﻿using System;
using System.Collections.Generic;
using System.Linq;
using SimulacniProstredi.Grafy;
using System.Drawing;
using System.Drawing.Drawing2D;
using SimulacniProstredi.Sceny;
using System.Text;

namespace SimulacniProstredi.Algoritmy
{
    class ARA
    {
        public bool Ended = false;
        double InflationFactor= 10;
        
        List<Vertex<VertexData_State_ARA, EdgeData_Heuristic>> AllNodes,Open, Closed, Incons, Solution = new List<Vertex<VertexData_State_ARA, EdgeData_Heuristic>>();
        Vertex<VertexData_State_ARA, EdgeData_Heuristic> Start, Goal,SmallestState;
        Scene ThisScene;
        private bool IsInList(Vertex<VertexData_State_ARA, EdgeData_Heuristic> Vertex, List<Vertex<VertexData_State_ARA, EdgeData_Heuristic>> Vertexes)
        {
            foreach (Vertex<VertexData_State_ARA, EdgeData_Heuristic> v in Vertexes)
            {
                if (Vertex.VertexData.Equals(v.VertexData)) { return true; }
            }
            return false;
        }

          public ARA(Scene InScene) 
        {
            AllNodes=new List<Vertex<VertexData_State_ARA,EdgeData_Heuristic>> ();
            ThisScene = InScene;
            Point instart = ThisScene.DetectPoint(ThisScene.Start);
            Point ingoal = ThisScene.DetectPoint(ThisScene.Goal);

            Goal = new Vertex<VertexData_State_ARA, EdgeData_Heuristic>(new VertexData_State_ARA(ingoal.X, ingoal.Y, new VertexData_State_ARA(ingoal.X, ingoal.Y)));
            Start = new Vertex<VertexData_State_ARA, EdgeData_Heuristic>(new VertexData_State_ARA(instart.X, instart.Y,Goal.VertexData));
        }

       void FindSmallestKey()
        {
                                double MinimalCost = Double.MaxValue;
                        int i = 0;
                        int idx = -1;
                        foreach (Vertex<VertexData_State_ARA, EdgeData_Heuristic> Item in Open)
                        {
                            if (Item.VertexData.GetKey < MinimalCost)
                            {
                                MinimalCost = Item.VertexData.GetKey;
                                idx = i;
                            }
                            i += 1;
                        }
                        SmallestState = Open[idx];            
        }
       void UpdateKey()
       {
           double MinimalCost = Double.MaxValue;
           int i = 0;
           int idx = -1;
           foreach (Vertex<VertexData_State_ARA, EdgeData_Heuristic> Item in Open)
           {
              Key(Item);
               if (Item.VertexData.GetKey < MinimalCost)
               {
                   MinimalCost = Item.VertexData.GetKey;
                   idx = i;
               }
               i += 1;
           }
           SmallestState = Open[idx];
       }

       void Key(Vertex<VertexData_State_ARA,EdgeData_Heuristic> inVertex)
        {
            inVertex.VertexData.SetKey= inVertex.VertexData.Getg + Convert.ToInt32(inVertex.VertexData.Geth * InflationFactor);
        }

       void ComputePath()
       {
        while(Goal.VertexData.GetKey>SmallestState.VertexData.GetKey)
        {
            Open.Remove(SmallestState);
            SmallestState.VertexData.Setv = SmallestState.VertexData.Getg;
            Closed.Add(SmallestState);
            ManageSuccesors(SmallestState);
            foreach (Edge<VertexData_State_ARA, EdgeData_Heuristic> e in SmallestState.GetOutputEdges)
            {
                if(e.GetIntoVertex.VertexData.Getg> (e.EdgeData.GetCost+SmallestState.VertexData.Getg))
                {
                e.GetIntoVertex.VertexData.Setg= (e.EdgeData.GetCost+SmallestState.VertexData.Getg);
                     if(IsInList(e.GetIntoVertex,Closed))
                     {
                        Incons.Add(e.GetIntoVertex);
                     }
                    else
                     {
                         Key(e.GetIntoVertex);
                         Open.Remove(Open.Find(delegate(Vertex<VertexData_State_ARA, EdgeData_Heuristic> v) { return v.VertexData.Equals(e.GetIntoVertex.VertexData); }));//mozna predela s ohledem na zasahy do fronty
                         Open.Add(e.GetIntoVertex);
                     }
                }
            }
            FindSmallestKey();
        }
       }

       void ManageSuccesors(Vertex<VertexData_State_ARA, EdgeData_Heuristic> Vertex)
       {
           if (Vertex.GetOutputEdges.Count() == 0)
           {
               List<VertexData_State_ARA> ListNewDataVertexex = Vertex.VertexData.Expand();

               foreach (VertexData_State_ARA v in ListNewDataVertexex)
               {

                   if ((v.X < (ThisScene.MaxMapSize.X)) & (v.Y < (ThisScene.MaxMapSize.Y)) & (v.X > 0) & (v.Y > 0))
                   {
                       Vertex<VertexData_State_ARA, EdgeData_Heuristic> Unit = new Vertex<VertexData_State_ARA, EdgeData_Heuristic>(v);
                       Vertex<VertexData_State_ARA, EdgeData_Heuristic> UnitAlredyInList = AllNodes.Find(delegate(Vertex<VertexData_State_ARA, EdgeData_Heuristic> AlreadyExpanded) { return AlreadyExpanded.VertexData.Equals(v); });
                       if (ThisScene.IsWalkable(Vertex.VertexData.X, Vertex.VertexData.Y, v.X, v.Y))
                       {

                           if (UnitAlredyInList != null)
                           {
                               Boolean FoundIt = false;
                               foreach (Edge<VertexData_State_ARA, EdgeData_Heuristic> e in UnitAlredyInList.GetInputEdges)
                               {
                                   if (e.GetOutVertex.VertexData.Equals(Vertex.VertexData)) FoundIt = true;
                               }
                               if (!FoundIt) { UnitAlredyInList.ConnectVertex(Vertex, new EdgeData_Heuristic(1), false); }
                           }
                           else
                           {
                               Unit.ConnectVertex(Vertex, new EdgeData_Heuristic(1), false);
                             
                               if (Unit.VertexData.Equals(Goal.VertexData))
                               { Goal = Unit; }

                               AllNodes.Add(Unit);
                           }

                       }
                       else
                       {
                           if (UnitAlredyInList != null)
                           {
                               Boolean FoundIt = false;
                               foreach (Edge<VertexData_State_ARA, EdgeData_Heuristic> e in UnitAlredyInList.GetInputEdges)
                               {
                                   if (e.GetOutVertex.VertexData.Equals(Vertex.VertexData)) FoundIt = true;
                               }
                               if (!FoundIt) { UnitAlredyInList.ConnectVertex(Vertex, new EdgeData_Heuristic(int.MaxValue / 2), false); }
                           }
                           else
                           {
                               Unit.ConnectVertex(Vertex, new EdgeData_Heuristic(int.MaxValue / 2), false);
                               AllNodes.Add(Unit);
                              
                           }
                       }
                   }
               }
           }
           }

       void DecreaseInflationFactor()
       {
          double  MinimalCost = Double.MaxValue;
          int  i = 0;
          int idx = -1;
           foreach (Vertex<VertexData_State_ARA, EdgeData_Heuristic> Item in Incons)
           {
               if ((Item.VertexData.Getg + Item.VertexData.Geth) < MinimalCost)
               {
                   MinimalCost = Item.VertexData.Getg + Item.VertexData.Geth;
                   idx = i;
               }
               i += 1;
           }
           Vertex<VertexData_State_ARA, EdgeData_Heuristic> SmallestStateIncons = Incons[idx];
           if ((SmallestState.VertexData.Getg + SmallestState.VertexData.Geth) < (SmallestStateIncons.VertexData.Geth + SmallestStateIncons.VertexData.Getg))
           {
               InflationFactor=Math.Min(InflationFactor,Goal.VertexData.Getg/(SmallestState.VertexData.Getg + SmallestState.VertexData.Geth));
           }
           else 
           {
               InflationFactor = Math.Min(InflationFactor, Goal.VertexData.Getg / (SmallestStateIncons.VertexData.Geth + SmallestStateIncons.VertexData.Getg));
           }
       }

       public void UseARA_FirstTime()
       {
           Start.VertexData.Setg = 0;
           Open = new List<Vertex<VertexData_State_ARA, EdgeData_Heuristic>>();
           Closed =new List<Vertex<VertexData_State_ARA,EdgeData_Heuristic>> ();
           Incons =new List<Vertex<VertexData_State_ARA,EdgeData_Heuristic>> ();
           Key(Goal);
           Key(Start);
           Open.Add(Start);
           FindSmallestKey();
           ComputePath();
           Solution.Add(Goal);
           ReconstructPath();
           
       }

       public void UseARA()
       {
           if (InflationFactor > 1)
           {
               DecreaseInflationFactor();
               Incons.ForEach(delegate(Vertex<VertexData_State_ARA, EdgeData_Heuristic> v) { Open.Add(v); });
               Incons.Clear();
               UpdateKey();
               Closed.Clear();
               ComputePath();
               Solution.Add(Goal);
               ReconstructPath();
       }
           else Ended = true;
       }

       void ReconstructPath()
       {//jit po nejniším g
           if (Solution == null) { return; }

           Vertex<VertexData_State_ARA, EdgeData_Heuristic> Path = Solution[0];

           while (Path.GetInputEdges.Count != 0)
           {
               int ming = Path.GetInputEdges[0].GetOutVertex.VertexData.Getg;  //Getg + Path.GetInputEdges[0].EdgeData.GetCost;
               int minEdgeNumber = 0; ;
               for (int i = 1; i < Path.GetInputEdges.Count(); i++)
               {
                   // if (!IsInList(Path.GetInputEdges[i].GetOutVertex, Solution))
                   if (Path.GetInputEdges[i].GetOutVertex.VertexData.Getg < ming) { ming = Path.GetInputEdges[i].GetOutVertex.VertexData.Getg; minEdgeNumber = i; }
                   //if ((Path.GetInputEdges[i].GetOutVertex.VertexData.Getg + Path.GetInputEdges[i].EdgeData.GetCost) < minRhs) { minRhs = Path.GetInputEdges[i].GetOutVertex.VertexData.Getg + Path.GetInputEdges[i].EdgeData.GetCost; minEdgeNumber = i; }

                   /* else if ((Path.GetInputEdges[i].GetOutVertex.VertexData.Getrhs == minRhs))
                   { if (IsInList(Path.GetInputEdges[minEdgeNumber].GetOutVertex, Solution)) { minEdgeNumber = i; } }*/
               }
               Solution.Insert(0, Path);
               Path = Path.GetInputEdges[minEdgeNumber].GetOutVertex;
           }
       }
       public List<Point> ReturnPoints()
       {
           List<Point> ListOfPoints = new List<Point>();
           foreach (Vertex<VertexData_State_ARA, EdgeData_Heuristic> v in Solution)
           {
               ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
           }
           return ListOfPoints;
       }
       public List<Point> ReturnSearchedNodes()
       {
           List<Point> ListOfPoints = new List<Point>();
           foreach (Vertex<VertexData_State_ARA, EdgeData_Heuristic> v in AllNodes)
           {
               ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
           }
           return ListOfPoints;
       }

    }
}
