﻿using System;
using System.Collections.Generic;
using System.Linq;
using SimulacniProstredi.Grafy;
using System.Drawing;
using System.Drawing.Drawing2D;
using SimulacniProstredi.Sceny;
using System.Text;


namespace SimulacniProstredi.Algoritmy
{
    class DLite
    {
        List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>> Solution, CurrentSolution, CurrentNodesList = new List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>>();
        List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>>  AllNodesList = new List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>>();
        Vertex<VertexData_State_DLite, EdgeData_Heuristic> StartVertex ,GoalVertex,Last,OriginalStart;
        int mkey;
        int[] oldkey, newkey;
        Scene ThisScene;
        PriorityQueue_DLite Queue;

        private bool IsInEdgeList(Edge<VertexData_State_DLite, EdgeData_Heuristic> edge, List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> Edges)
        {
            foreach (Edge<VertexData_State_DLite, EdgeData_Heuristic> e in Edges)
            {
                if (edge.Equals(e))
                { return true; }
            }
            return false;
        }
        private bool IsInList(Vertex<VertexData_State_DLite, EdgeData_Heuristic> Vertex, List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>> Vertexes)
        {
            foreach (Vertex<VertexData_State_DLite, EdgeData_Heuristic> v in Vertexes)
            {
                if (Vertex.VertexData.Equals(v.VertexData)) { return true; }
            }
            return false;
        }

        bool LessVector(int[] a, int[] b)
        { 
            if ((a[0] < b[0]) | ((a[0] == b[0]) & (a[1] < b[1]))) return true;
            else return false;
        }

        int[] CalculateKey(Vertex<VertexData_State_DLite, EdgeData_Heuristic> inVertex)
        { int[] key=new int[2]; 
          key[0] = Math.Min(inVertex.VertexData.Getg,inVertex.VertexData.Getrhs + inVertex.VertexData.Geth(StartVertex.VertexData) + mkey); 
            key[1] = Math.Min(inVertex.VertexData.Getg,inVertex.VertexData.Getrhs); 
            return key; 
        }
         public DLite(Scene InScene) 
        {
            ThisScene = InScene;
            Point instart = ThisScene.DetectPoint(ThisScene.Start);
            Point ingoal = ThisScene.DetectPoint(ThisScene.Goal);

            GoalVertex = new Vertex<VertexData_State_DLite, EdgeData_Heuristic>(new VertexData_State_DLite(ingoal.X, ingoal.Y));
            StartVertex = new Vertex<VertexData_State_DLite, EdgeData_Heuristic>(new VertexData_State_DLite(instart.X, instart.Y));
        }

        void Initialize()
        {
            Queue = new PriorityQueue_DLite();
            mkey = 0;
            GoalVertex.VertexData.InitializeVertexData();
            StartVertex.VertexData.InitializeVertexData();
            GoalVertex.VertexData.Setrhs = 0;
            Queue.Insert(GoalVertex, QueueUnit_DLite.ToPriority(GoalVertex.VertexData.Geth(StartVertex.VertexData), 0));
        }

        void UpdateVertex(Vertex<VertexData_State_DLite, EdgeData_Heuristic> inVertex)
        {
           
            if ((Queue.IsInQueue(inVertex)) & (inVertex.VertexData.Getg != inVertex.VertexData.Getrhs)) Queue.Update(inVertex,CalculateKey(inVertex));
            else if ((Queue.IsInQueue(inVertex)) & (inVertex.VertexData.Getg == inVertex.VertexData.Getrhs)) Queue.Remove(inVertex);
            else if (!(Queue.IsInQueue(inVertex)) & (inVertex.VertexData.Getg != inVertex.VertexData.Getrhs)/* & !IsInList(inVertex, AllNodesList)*/)
            {
              
                Queue.Insert(inVertex, CalculateKey(inVertex));
               CurrentNodesList.Add(inVertex);
            }
        }

        void ManagePreddecesors(Vertex<VertexData_State_DLite, EdgeData_Heuristic> inVertex)
        {
            if (inVertex.GetInputEdges.Count() == 0)
            {
                List<VertexData_State_DLite> ListNewDataVertexex = inVertex.VertexData.Expand();

                foreach (VertexData_State_DLite v in ListNewDataVertexex)
                {

                    if ((v.X < (ThisScene.MaxMapSize.X)) & (v.Y < (ThisScene.MaxMapSize.Y)) & (v.X > 0) & (v.Y > 0))
                    {
                        Vertex<VertexData_State_DLite, EdgeData_Heuristic> Unit = new Vertex<VertexData_State_DLite, EdgeData_Heuristic>(v);
                        Vertex<VertexData_State_DLite, EdgeData_Heuristic> UnitAlredyInList = AllNodesList.Find(delegate(Vertex<VertexData_State_DLite, EdgeData_Heuristic> AlreadyExpanded) { return AlreadyExpanded.VertexData.Equals(v); });

                        if (ThisScene.IsWalkable(inVertex.VertexData.X, inVertex.VertexData.Y, v.X, v.Y))
                        {

                            if (UnitAlredyInList != null)
                            {
                                Boolean FoundIt = false;
                                foreach (Edge<VertexData_State_DLite, EdgeData_Heuristic> e in UnitAlredyInList.GetOutputEdges)
                                {
                                    if (e.GetIntoVertex.VertexData.Equals(inVertex.VertexData)) FoundIt = true;
                                }
                                if (!FoundIt) { UnitAlredyInList.ConnectVertex(inVertex, new EdgeData_Heuristic(1), true); }
                            }
                            else
                            {
                                Unit.ConnectVertex(inVertex, new EdgeData_Heuristic(1), true);
                                Unit.VertexData.InitializeVertexData();
                                if (Unit.VertexData.Equals(StartVertex.VertexData))
                                { StartVertex = Unit; }
                               // CurrentNodesList.Add(Unit);
                                AllNodesList.Add(Unit);
                            }

                        }
                        else
                        {
                            if (UnitAlredyInList != null)
                            {
                                Boolean FoundIt = false;
                                foreach (Edge<VertexData_State_DLite, EdgeData_Heuristic> e in UnitAlredyInList.GetOutputEdges)
                                {
                                    if (e.GetIntoVertex.VertexData.Equals(inVertex.VertexData)) FoundIt = true;
                                }
                                if (!FoundIt)
                                { UnitAlredyInList.ConnectVertex(inVertex, new EdgeData_Heuristic(int.MaxValue / 2), true ); 
                                   // UnitAlredyInList.RemoveVertex();
                                }
                            }
                            else
                            {
                                Unit.ConnectVertex(inVertex, new EdgeData_Heuristic(int.MaxValue / 2), true);
                                Unit.VertexData.InitializeVertexData();
                               AllNodesList.Add(Unit);
                               
                            }
                        }
                    }
                }

            }
           

        }

        void ComputeShrotestPath()
        {
            int ComputeRuns = 0;
            while((LessVector(Queue.TopKey,CalculateKey(StartVertex))) | (StartVertex.VertexData.Getrhs > StartVertex.VertexData.Getg))
            {
                ComputeRuns = ComputeRuns + 1;
            Vertex<VertexData_State_DLite, EdgeData_Heuristic> Vertex = Queue.Pop();
            ManagePreddecesors(Vertex);
                oldkey = Queue.TopKey;
                newkey=CalculateKey(Vertex);
                if(LessVector(oldkey,newkey))
                {
                    Queue.Update(Vertex, newkey);
                }
                else if (Vertex.VertexData.Getg > Vertex.VertexData.Getrhs)
                {
                    Vertex.VertexData.Setg = Vertex.VertexData.Getrhs;
                    Queue.Remove(Vertex);
             
                    foreach (Edge<VertexData_State_DLite, EdgeData_Heuristic> e in Vertex.GetInputEdges )
                    {
                        e.GetOutVertex.VertexData.Setrhs = Math.Min(e.GetOutVertex.VertexData.Getrhs, Vertex.VertexData.Getg + e.EdgeData.GetCost);
                        UpdateVertex(e.GetOutVertex);
                    }
                }
                else
                {
                    int oldg = Vertex.VertexData.Getg;
                    Vertex.VertexData.Setg = int.MaxValue / 3;
              
                    foreach (Edge<VertexData_State_DLite, EdgeData_Heuristic> e in Vertex.GetInputEdges)
                    {
                        if (e.GetOutVertex.VertexData.Getrhs == oldg + e.EdgeData.GetCost)
                        {
                            if ((!e.GetOutVertex.VertexData.Equals(GoalVertex.VertexData))&(e.GetOutVertex.GetOutputEdges.Count()>0))
                            {
                                int minRhs =  e.GetOutVertex.GetOutputEdges[0].GetIntoVertex.VertexData.Getg +e.GetOutVertex.GetOutputEdges[0].EdgeData.GetCost;
                                for (int i = 1; i < e.GetOutVertex.GetOutputEdges.Count(); i++)
                                {
                                    if ((e.GetOutVertex.GetOutputEdges[i].GetIntoVertex.VertexData.Getg +e.GetOutVertex.GetOutputEdges[i].EdgeData.GetCost) < minRhs) { minRhs = e.GetOutVertex.GetOutputEdges[i].GetIntoVertex.VertexData.Getg +e.GetOutVertex.GetOutputEdges[i].EdgeData.GetCost; }
                                }
                                e.GetOutVertex.VertexData.Setrhs = minRhs;
                            }
                        }
                        UpdateVertex(e.GetOutVertex);
                    }
                    if (Vertex.VertexData.Getrhs == oldg)
                    {
                        if ((Vertex.VertexData.Equals(GoalVertex.VertexData)) & (Vertex.GetOutputEdges.Count() > 0))
                        {
                            int minRhs = Vertex.GetOutputEdges[0].GetIntoVertex.VertexData.Getg + Vertex.GetOutputEdges[0].EdgeData.GetCost;
                            for (int i = 1; i < Vertex.GetOutputEdges.Count(); i++)
                            {
                                if ((Vertex.GetOutputEdges[i].GetIntoVertex.VertexData.Getg + Vertex.GetOutputEdges[i].EdgeData.GetCost) < minRhs) { minRhs = Vertex.GetOutputEdges[i].GetIntoVertex.VertexData.Getg + Vertex.GetOutputEdges[i].EdgeData.GetCost; }
                            }
                            Vertex.VertexData.Setrhs = minRhs;
                        }
                    }
                    UpdateVertex(Vertex);
                }
            }

        
        }
        void ReconstructPath()
        {
            if (Solution == null) { return; }

            Vertex<VertexData_State_DLite, EdgeData_Heuristic> Path = Solution[0];


            while (Path.GetOutputEdges.Count != 0)
            {
                int minRhs = int.MaxValue ;
                int minEdgeNumber=0 ;
                bool found = false;
                for (int i = 0; i < Path.GetOutputEdges.Count(); i++)
                {
                   
                    if ((Path.GetOutputEdges[i].GetIntoVertex.VertexData.Getrhs < minRhs) & (Path.GetOutputEdges[i].EdgeData.GetCost != (int.MaxValue / 2)) & (!IsInList(Path.GetOutputEdges[i].GetIntoVertex, Solution))) { minRhs = Path.GetOutputEdges[i].GetIntoVertex.VertexData.Getrhs; minEdgeNumber = i; found = true; }
                  
                }
                if (found == false)
                {
                    break;
                }
                Solution.Insert(0, Path);

                
                Path = Path.GetOutputEdges[minEdgeNumber].GetIntoVertex;
            }
        }



        public void UseDLite_FirstTime()
        {
            Last = StartVertex;
            Initialize();
            ComputeShrotestPath();
            Solution = new List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>>();
            Solution.Add(StartVertex);
            ReconstructPath();
        }

        public void UseDLite()
        {
            CurrentSolution  = new List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>>();
            OriginalStart = StartVertex;

           while (!StartVertex.VertexData.Equals(GoalVertex.VertexData))
            {

                int EdgeNumber = 0;
                int minRhs = StartVertex.GetOutputEdges[0].GetIntoVertex.VertexData.Getg + StartVertex.GetOutputEdges[0].EdgeData.GetCost;
                for (int i = 1; i < StartVertex.GetOutputEdges.Count(); i++)
                {
                    if ((StartVertex.GetOutputEdges[i].GetIntoVertex.VertexData.Getg + StartVertex.GetOutputEdges[i].EdgeData.GetCost) < minRhs) { minRhs = StartVertex.GetOutputEdges[i].GetIntoVertex.VertexData.Getg + StartVertex.GetOutputEdges[i].EdgeData.GetCost; EdgeNumber = i; }
                }
                StartVertex = StartVertex.GetOutputEdges[EdgeNumber].GetIntoVertex;
                CurrentSolution.Add(StartVertex);
            
                List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> ListOfEdges = new List<Edge<VertexData_State_DLite, EdgeData_Heuristic>>();
                List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> ListOfRemovedEdges = new List<Edge<VertexData_State_DLite, EdgeData_Heuristic>>();
              
               ListOfEdges = ScanForChangedEdgesOfGraph(StartVertex);
               ListOfRemovedEdges = CheckEdgeForRemovedEdges();
 
               if ((ListOfEdges.Count() > 0) | (ListOfRemovedEdges.Count() > 0))
                {
                    mkey = mkey + StartVertex.VertexData.Geth(Last.VertexData);
                    Last = StartVertex;
                    ListOfEdges.ForEach(delegate(Edge<VertexData_State_DLite, EdgeData_Heuristic> e)
                {
                    int CostOld = e.EdgeData.GetCost;
                    e.EdgeData.SetCost = (int.MaxValue / 2);
                });
                    ListOfEdges.ForEach(delegate(Edge<VertexData_State_DLite, EdgeData_Heuristic> e)
                    {
                        UpdateRhs_cOldSmaller(e.GetOutVertex);
                    });
                    ListOfEdges.ForEach(delegate(Edge<VertexData_State_DLite, EdgeData_Heuristic> e)
                   {
                       UpdateVertex(e.GetOutVertex);
                   });
                   
                    ListOfRemovedEdges.ForEach(delegate(Edge<VertexData_State_DLite, EdgeData_Heuristic> e)
                    {
                        int CostOld = e.EdgeData.GetCost;
                        e.EdgeData.SetCost = 1;
                    });
                    ListOfRemovedEdges.ForEach(delegate(Edge<VertexData_State_DLite, EdgeData_Heuristic> e)
                    {
                        UpdateRhs_cOldBigger(e);
                    });
                    ListOfRemovedEdges.ForEach(delegate(Edge<VertexData_State_DLite, EdgeData_Heuristic> e)
                    {
                        UpdateVertex(e.GetOutVertex);
                    });
                  
                   StartVertex.VertexData.InitializeVertexDataForSecondSearch();//mozna zakomentovat
                   CurrentNodesList = new List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>>();
                    ComputeShrotestPath();

                    //mozna smazat
                   Solution = new List<Vertex<VertexData_State_DLite, EdgeData_Heuristic>>();
                  Solution.Add(StartVertex);
                  ReconstructPath();

                   break;
                  
                }
   
           }
           StartVertex = OriginalStart;
        }

        void UpdateRhs_cOldSmaller(Vertex<VertexData_State_DLite, EdgeData_Heuristic> inVertex)
        {
            if (!inVertex.VertexData.Equals(StartVertex.VertexData))
            {
                int minRhs2 = inVertex.GetOutputEdges[0].GetIntoVertex.VertexData.Getg + inVertex.GetOutputEdges[0].EdgeData.GetCost;
                for (int i = 1; i < inVertex.GetOutputEdges.Count(); i++)
                {
                    if ((inVertex.GetOutputEdges[i].GetIntoVertex.VertexData.Getg + inVertex.GetOutputEdges[i].EdgeData.GetCost) < minRhs2) { minRhs2 = inVertex.GetOutputEdges[i].GetIntoVertex.VertexData.Getg + inVertex.GetOutputEdges[i].EdgeData.GetCost; }
                }
                inVertex.VertexData.Setrhs = minRhs2;
            }
        }
        void UpdateRhs_cOldBigger(Edge<VertexData_State_DLite, EdgeData_Heuristic> inEdge)
        {
            inEdge.GetOutVertex.VertexData.Setrhs = Math.Min(inEdge.GetOutVertex.VertexData.Getrhs, inEdge.GetIntoVertex.VertexData.Getg + inEdge.EdgeData.GetCost);
        }
        public List<Point> ReturnPoints()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_DLite, EdgeData_Heuristic> v in Solution)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }
        public List<Point> ReturnPointsCurrent()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_DLite, EdgeData_Heuristic> v in CurrentSolution)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }
        public List<Point> ReturnSearchedNodes()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_DLite, EdgeData_Heuristic> v in AllNodesList)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }
        public List<Point> ReturnNewlySearchedNodes()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_DLite, EdgeData_Heuristic> v in CurrentNodesList)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }

        int pocetrekurzi = 0;

        List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> CheckEdge()
        {
            pocetrekurzi = pocetrekurzi + 1;
        List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> ListOfEdges = new List<Edge<VertexData_State_DLite, EdgeData_Heuristic>>();
    
            AllNodesList.ForEach(delegate(Vertex<VertexData_State_DLite, EdgeData_Heuristic> v) {
                foreach (Edge<VertexData_State_DLite, EdgeData_Heuristic> e in v.GetInputEdges)
                {

                    if (!ThisScene.IsWalkable(e.GetIntoVertex.VertexData.X, e.GetIntoVertex.VertexData.Y, e.GetOutVertex.VertexData.X, e.GetOutVertex.VertexData.Y))
                    {
                        if (e.EdgeData.GetCost < (int.MaxValue / 2))
                        {
                            if (!IsInEdgeList(e, ListOfEdges)) ListOfEdges.Add(e);
                        }
                    }
                }
            });
    return ListOfEdges;      
        }

        List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> CheckEdgeForRemovedEdges()
        {

          
            List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> ListOfEdges = new List<Edge<VertexData_State_DLite, EdgeData_Heuristic>>();
            AllNodesList.ForEach(delegate(Vertex<VertexData_State_DLite, EdgeData_Heuristic> v)
            {
             foreach (Edge<VertexData_State_DLite, EdgeData_Heuristic> e in v.GetInputEdges)
            {

                    if (e.EdgeData.GetCost == (int.MaxValue / 2))
                    {
                        if (ThisScene.IsWalkable(e.GetIntoVertex.VertexData.X, e.GetIntoVertex.VertexData.Y, e.GetOutVertex.VertexData.X, e.GetOutVertex.VertexData.Y))
                    {

                            if (!IsInEdgeList(e, ListOfEdges)) ListOfEdges.Add(e);
                        }
                    }
                }
            });
            return ListOfEdges;
        } 




        List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> ScanForChangedEdgesOfGraph(Vertex<VertexData_State_DLite, EdgeData_Heuristic> inVertex)
        {
            List<Edge<VertexData_State_DLite, EdgeData_Heuristic>> ListOfChanges = new List<Edge<VertexData_State_DLite, EdgeData_Heuristic>>();
                Solution.ForEach(delegate(Vertex<VertexData_State_DLite, EdgeData_Heuristic> v)
                {
                    if (CheckEdgesOfVertex(v) == true) { ListOfChanges = CheckEdge(); }
                }
            );

                return ListOfChanges;

        }

        bool CheckEdgesOfVertex(Vertex<VertexData_State_DLite, EdgeData_Heuristic> inVertex)
        {
             foreach (Edge<VertexData_State_DLite, EdgeData_Heuristic> e in inVertex.GetInputEdges)
          
                {

                    if (!ThisScene.IsWalkable(e.GetOutVertex.VertexData.X, e.GetOutVertex.VertexData.Y, e.GetIntoVertex.VertexData.X, e.GetIntoVertex.VertexData.Y))
                    {
                        if (e.EdgeData.GetCost < (int.MaxValue / 2))
                        {
                            return true;
                        }
                    }
                }
            return false;
        }
       
       
    }

}
