﻿using System;
using System.Collections.Generic;
using System.Linq;
using SimulacniProstredi.Grafy;
using System.Drawing;
using System.Drawing.Drawing2D;
using SimulacniProstredi.Sceny;
using System.Text;

namespace SimulacniProstredi.Algoritmy
{
    class DStar
    {
        List<Vertex<VertexData_State_Dstar, EdgeData_Heuristic>> AllNodesList, CurrentNodesList = new List<Vertex<VertexData_State_Dstar, EdgeData_Heuristic>>();
        Vertex<VertexData_State_Dstar, EdgeData_Heuristic> Start, Goal;
        Scene ThisScene;
        List<Vertex<VertexData_State_Dstar, EdgeData_Heuristic>> Solution = new List<Vertex<VertexData_State_Dstar, EdgeData_Heuristic>>();
        List<Vertex<VertexData_State_Dstar, EdgeData_Heuristic>> Open = new List<Vertex<VertexData_State_Dstar, EdgeData_Heuristic>>();
       
        public int NumberOfMathOperations = 0;

        int oldkey;
        int maxkey = int.MaxValue / 2;
        int NoVal = int.MinValue / 2;
        Vertex<VertexData_State_Dstar, EdgeData_Heuristic> ThisState;
        Vertex<VertexData_State_Dstar, EdgeData_Heuristic> PrevState;

        private bool IsInList(Vertex<VertexData_State_Dstar, EdgeData_Heuristic> Vertex, List<Vertex<VertexData_State_Dstar, EdgeData_Heuristic>> Vertexes)
        {
            foreach (Vertex<VertexData_State_Dstar, EdgeData_Heuristic> v in Vertexes)
            {
                if (Vertex.VertexData.Equals(v.VertexData)) { return true; }
            }
            return false;
        }

        bool Less(int a, int b)
        { //basic D*
        if (a<b) return true ;
            else return false;
        }

        bool LessVector(int[] a, int[] b)
        { //focussed D*
            if ((a[0] < b[0]) |((a[0] == b[0])&(a[1] < b[1]))) return true;
            else return false;
        }

        public DStar(Scene InScene)
        {
            ThisScene = InScene;
            Point instart = ThisScene.DetectPoint(ThisScene.Start);
            Point ingoal = ThisScene.DetectPoint(ThisScene.Goal);

            Goal = new Vertex<VertexData_State_Dstar, EdgeData_Heuristic>(new VertexData_State_Dstar(ingoal.X, ingoal.Y, new VertexData_State_Dstar(ingoal.X, ingoal.Y)));
            Start = new Vertex<VertexData_State_Dstar, EdgeData_Heuristic> (new VertexData_State_Dstar(instart.X, instart.Y, Goal.VertexData));
        }

        Vertex<VertexData_State_Dstar, EdgeData_Heuristic> MinState()
        {

            double MinimalKey = Double.MaxValue;
            int i = 0;
            int idx = -1;
            foreach (Vertex<VertexData_State_Dstar, EdgeData_Heuristic> Item in Open)
            {
                if (Item.VertexData.key < MinimalKey)
                {
                    MinimalKey = Item.VertexData.key;
                    idx = i;
                }
                i += 1;
            }
            return Open[idx];
        }


        int MinVal()
        { 

            if (Open.Count() > 0)
           return MinState().VertexData.key;
            else return NoVal;
        }
        void Delete(Vertex<VertexData_State_Dstar, EdgeData_Heuristic> inVertex)
        {
            inVertex.VertexData.SetTag = 2;
            Open.Remove(inVertex);
        }

        void Insert(Vertex<VertexData_State_Dstar, EdgeData_Heuristic> inVertex, int Hnew)
        {
            Open.Remove(inVertex);
        if (inVertex.VertexData.GetTag==0) inVertex.VertexData.key=Hnew;
            else if (inVertex.VertexData.GetTag==1) inVertex.VertexData.key=Math.Min(inVertex.VertexData.key,Hnew);
        else if (inVertex.VertexData.GetTag == 2) inVertex.VertexData.key = Math.Min(inVertex.VertexData.GetH , Hnew);
        inVertex.VertexData.SetH = Hnew;
        inVertex.VertexData.SetTag = 1;
        Open.Add(inVertex);

        }

        void PutState(Vertex<VertexData_State_Dstar, EdgeData_Heuristic> inVertex)
        {
            inVertex.VertexData.SetTag = 1;
            Open.Add(inVertex);
        }

        Vertex<VertexData_State_Dstar, EdgeData_Heuristic> GetState()
        {
            return null;
        }

        void ManageSuccesors(Vertex<VertexData_State_Dstar, EdgeData_Heuristic> inVertex)
        {
            if (inVertex.GetOutputEdges.Count() == 0)
            {
                List<VertexData_State_Dstar> ListNewDataVertexex = inVertex.VertexData.Expand();

                foreach (VertexData_State_Dstar v in ListNewDataVertexex)
                {

                    if ((v.X < (ThisScene.MaxMapSize.X)) & (v.Y < (ThisScene.MaxMapSize.Y)) & (v.X > 0) & (v.Y > 0))
                    {
                        Vertex<VertexData_State_Dstar, EdgeData_Heuristic> Unit = new Vertex<VertexData_State_Dstar, EdgeData_Heuristic>(v);
                        Vertex<VertexData_State_Dstar, EdgeData_Heuristic> UnitAlredyInList = AllNodesList.Find(delegate(Vertex<VertexData_State_Dstar, EdgeData_Heuristic> AlreadyExpanded) {return AlreadyExpanded.VertexData.Equals(v);});
                       
                        if (ThisScene.IsWalkable(inVertex.VertexData.X, inVertex.VertexData.Y, v.X, v.Y))
                        {

                            if (UnitAlredyInList != null) 
                            {
                                Boolean FoundIt = false;
                                foreach (Edge<VertexData_State_Dstar, EdgeData_Heuristic> e in UnitAlredyInList.GetInputEdges)
                                {
                                    if (e.GetOutVertex.VertexData.Equals(inVertex.VertexData)) FoundIt = true;
                                }
                                if (!FoundIt) { UnitAlredyInList.ConnectVertex(inVertex, new EdgeData_Heuristic(1), false); }
                            }
                            else
                            {
                                Unit.ConnectVertex(inVertex, new EdgeData_Heuristic(1), false);
                               // Unit.VertexData.Computeh();
                                if (Unit.VertexData.Equals(Start.VertexData)) 
                                { Start = Unit; }
                                
                                AllNodesList.Add(Unit);
                            }

                        }
                        else
                        {
                            if (UnitAlredyInList != null)
                            {
                                Boolean FoundIt = false;
                                foreach (Edge<VertexData_State_Dstar, EdgeData_Heuristic> e in UnitAlredyInList.GetInputEdges)
                                {
                                    if (e.GetOutVertex.VertexData.Equals(inVertex.VertexData)) FoundIt = true;
                                }
                                if (!FoundIt) { UnitAlredyInList.ConnectVertex(inVertex, new EdgeData_Heuristic(int.MaxValue / 2), false); }
                            }
                            else
                            {
                                Unit.ConnectVertex(inVertex, new EdgeData_Heuristic(int.MaxValue/2), false);
                                AllNodesList.Add(Unit);
                        
                            }
                        }
                    }
                } 
            }
        }
    
        int ProcessState2()
        {
            Vertex<VertexData_State_Dstar, EdgeData_Heuristic> State_X = MinState();
            if (State_X == null) return NoVal;
            oldkey = State_X.VertexData.key;
            Delete(State_X);
            ManageSuccesors(State_X);
            if (oldkey < State_X.VertexData.GetH)
            {
                foreach (Edge<VertexData_State_Dstar, EdgeData_Heuristic> e in State_X.GetOutputEdges)
                {
                    if ((e.GetIntoVertex.VertexData.GetTag != 0) & (e.GetIntoVertex.VertexData.GetH <= oldkey) & (State_X.VertexData.GetH > (e.GetIntoVertex.VertexData.GetH + e.EdgeData.GetCost)))
                    { State_X.VertexData.SetBackpointer = e.GetIntoVertex; State_X.VertexData.SetH = e.GetIntoVertex.VertexData.GetH + e.EdgeData.GetCost; }
                

                }

            } 
             if (oldkey == State_X.VertexData.GetH) 
            {
                foreach (Edge<VertexData_State_Dstar, EdgeData_Heuristic> e in State_X.GetOutputEdges)
                {
                    if (e.GetIntoVertex.VertexData.GetBackpointer == null)
                    {
                        if (e.GetIntoVertex.VertexData.GetTag == 0)
                        {
                            e.GetIntoVertex.VertexData.SetBackpointer = State_X;
                            Insert(e.GetIntoVertex, State_X.VertexData.GetH + e.EdgeData.GetCost);
                        }
                    }
                    else 
                    {
                        if ((e.GetIntoVertex.VertexData.GetTag == 0) | ((e.GetIntoVertex.VertexData.GetBackpointer.VertexData.Equals(State_X.VertexData)) & (e.GetIntoVertex.VertexData.GetH != State_X.VertexData.GetH + e.EdgeData.GetCost)) | ((!e.GetIntoVertex.VertexData.GetBackpointer.VertexData.Equals(State_X.VertexData)) & (e.GetIntoVertex.VertexData.GetH > State_X.VertexData.GetH + e.EdgeData.GetCost)))
                        {
                            e.GetIntoVertex.VertexData.SetBackpointer = State_X;
                            Insert(e.GetIntoVertex, State_X.VertexData.GetH + e.EdgeData.GetCost);
                        }
                    }
                }
            }
            else 
            {
                foreach (Edge<VertexData_State_Dstar, EdgeData_Heuristic> e in State_X.GetOutputEdges)
                {
                    if (e.GetIntoVertex.VertexData.GetBackpointer == null)
                    {
                        if (e.GetIntoVertex.VertexData.GetTag == 0) 
                        {
                            e.GetIntoVertex.VertexData.SetBackpointer = State_X;
                            Insert(e.GetIntoVertex, State_X.VertexData.GetH + e.EdgeData.GetCost);
                        }
                    }
                    else
                    {
                        if ((e.GetIntoVertex.VertexData.GetTag == 0) | ((e.GetIntoVertex.VertexData.GetBackpointer.VertexData.Equals(State_X.VertexData)) & (e.GetIntoVertex.VertexData.GetH != State_X.VertexData.GetH + e.EdgeData.GetCost)))
                        {
                            e.GetIntoVertex.VertexData.SetBackpointer = State_X;
                            Insert(e.GetIntoVertex, State_X.VertexData.GetH + e.EdgeData.GetCost);
                        }
                        else
                        {
                            if ((!e.GetIntoVertex.VertexData.GetBackpointer.VertexData.Equals(State_X.VertexData)) & (e.GetIntoVertex.VertexData.GetH > (State_X.VertexData.GetH + e.EdgeData.GetCost)) & (e.GetIntoVertex.VertexData.GetTag == 2)) Insert(State_X, State_X.VertexData.GetH);
                            else if ((!e.GetIntoVertex.VertexData.GetBackpointer.VertexData.Equals(State_X.VertexData)) & (State_X.VertexData.GetH > (e.GetIntoVertex.VertexData.GetH + e.EdgeData.GetCost)) & (e.GetIntoVertex.VertexData.GetTag == 2) & (e.GetIntoVertex.VertexData.GetH > oldkey)) Insert(e.GetIntoVertex, e.GetIntoVertex.VertexData.GetH);
                        }
                    }
                }
            }
            return MinVal();
        
        }

        int ProcessState()
        {
            Vertex<VertexData_State_Dstar, EdgeData_Heuristic> State_X = MinState();
            if (State_X == null) return NoVal;
            oldkey = State_X.VertexData.key;
            Delete(State_X);
            ManageSuccesors(State_X);
            foreach (Edge<VertexData_State_Dstar, EdgeData_Heuristic> e in State_X.GetOutputEdges)
            {

                if (e.GetIntoVertex.VertexData.GetBackpointer !=null)
                {
                    if ((e.GetIntoVertex.VertexData.GetTag == 0) |((e.GetIntoVertex.VertexData.GetBackpointer.VertexData.Equals(State_X.VertexData))&(e.GetIntoVertex.VertexData.GetH !=(State_X.VertexData.GetH +e.EdgeData.GetCost))))//L5
                    {
                        e.GetIntoVertex.VertexData.SetBackpointer = State_X;
                        Insert(e.GetIntoVertex,State_X.VertexData.GetH+e.EdgeData.GetCost);
                    }
                    else //L7
                    {
                        if ((!e.GetIntoVertex.VertexData.GetBackpointer.VertexData.Equals(State_X.VertexData)&(e.GetIntoVertex.VertexData.GetH >(State_X.VertexData.GetH +e.EdgeData.GetCost))))//L8
                        {
                            if (State_X.VertexData.GetH>oldkey)//L9
                            {
                                if(State_X.VertexData.GetTag==2) Insert(State_X,State_X.VertexData.GetH);//L10
                            }
                            else //L11
                            { 
                                e.GetIntoVertex.VertexData.SetBackpointer = State_X;
                                Insert(e.GetIntoVertex,State_X.VertexData.GetH+e.EdgeData.GetCost);
                            }
                        }
                        else //L13
                        { 
                            if ((!e.GetIntoVertex.VertexData.GetBackpointer.VertexData.Equals(State_X.VertexData)) & (State_X.VertexData.GetH >(e.GetIntoVertex.VertexData.GetH+e.EdgeData.GetCost)))//L14
                            {
                                if (e.GetIntoVertex.VertexData.GetH > oldkey)//L15
                                {
                                    if (e.GetIntoVertex.VertexData.GetTag == 2) 
                                        Insert(e.GetIntoVertex, e.GetIntoVertex.VertexData.GetH);//L16
                                }
                                else //L17
                                {
                                    State_X.VertexData.SetBackpointer = e.GetIntoVertex;
                                    Insert(State_X,e.GetIntoVertex.VertexData.GetH +e.EdgeData.GetCost);
                                }
                            }
                        }
                    }
                }
                 else if(e.GetIntoVertex.VertexData.GetTag == 0)
                {
                e.GetIntoVertex.VertexData.SetBackpointer = State_X;
                        Insert(e.GetIntoVertex,State_X.VertexData.GetH+e.EdgeData.GetCost);
                }
            }
            return MinVal();
        }



        int ModifyCost(Vertex<VertexData_State_Dstar, EdgeData_Heuristic> State_X, Vertex<VertexData_State_Dstar, EdgeData_Heuristic> State_Y, int cval)
        { 
        State_Y.GetInputEdges.Find(delegate(Edge<VertexData_State_Dstar, EdgeData_Heuristic> e) { return e.GetOutVertex.VertexData.Equals(State_X.VertexData); }).EdgeData.SetCost =cval;
        if (State_X.VertexData.GetTag == 2) Insert(State_X, State_X.VertexData.GetH);
        return MinVal();
        }

      public  void MoveRobot()
        {
            Insert(Goal, 0);
            int val = 0;
              while((Start.VertexData.GetTag!=2)&(val!=NoVal ))
              {
                  val =ProcessState();
              }
            if (Start.VertexData.GetTag ==0) return  ;
 ThisState = Start;
              while(!ThisState.VertexData.Equals(Goal.VertexData))
              {
                
                 foreach (Edge<VertexData_State_Dstar, EdgeData_Heuristic> e in ThisState.GetOutputEdges)
                {
                if (!ThisScene.IsWalkable(ThisState.VertexData.X,ThisState.VertexData.Y,e.GetIntoVertex.VertexData.X,e.GetIntoVertex.VertexData.Y)) val = ModifyCost(ThisState,e.GetIntoVertex,int.MaxValue/2);
                }


                  while ((Less(val, ThisState.VertexData.Cost)) & (val != NoVal))
                  {
                      val = ProcessState();
                  }
                  ThisState = ThisState.VertexData.GetBackpointer;
              }
              ReconstructPath();
        }
        void ReconstructPath()
        {
            Vertex<VertexData_State_Dstar, EdgeData_Heuristic> Path = Goal;
            while (Path.VertexData.GetBackpointer != null)
            {
                Solution.Insert(0, Path);
                Path = Path.VertexData.GetBackpointer;
            }
        }
        public List<Point> ReturnPoints()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_Dstar, EdgeData_Heuristic> v in Solution)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }
        public List<Point> ReturnSearchedNodes()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_Dstar, EdgeData_Heuristic> v in AllNodesList)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }
        public List<Point> ReturnNewlySearchedNodes()
        {
            List<Point> ListOfPoints = new List<Point>();
            foreach (Vertex<VertexData_State_Dstar, EdgeData_Heuristic> v in CurrentNodesList)
            {
                ListOfPoints.Add(ThisScene.PointsOfHexagonalLattice[Convert.ToInt32(v.VertexData.X), Convert.ToInt32(v.VertexData.Y)]);
            }
            return ListOfPoints;
        }
    }
}
