﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using SimulacniProstredi.GUI;
using SimulacniProstredi.Sceny;


namespace SimulacniProstredi
{
 
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


 
        }
        public Scene ProjectScene = new Scene();
        public GUIPaint GUI ;


        private void Form1_Load(object sender, EventArgs e)
        {
            pictureScene.Image = (Image)(new Bitmap(pictureScene.Width, pictureScene.Height));
            pictureScene = GUIPaint.CreateFrame(pictureScene);
            GUI = new GUIPaint(this, radioLine, radioRectangle, radioPolygon, radioPen, radioEraser, ProjectScene.GridBmpNoPath);
            lblLenghtofPath.Text = "";
            lblNumberOfStates.Text = "";
            lblTime.Text = "";
            lblNumberOfNewStates.Text = "";
            cbAlgoritms.Items.AddRange(new object[] {"A*",
                       // "Dynamic A*",
                        "Dynamic A* Lite Second version",
                        "Anytime Repairing A*",
                        "Anytime Dynamic A*",
                        "Global Lifelong Planning A*"});
            cbAlgoritms.SelectedIndex = 0;
         

  
        }

        #region Save/Load
        private void btnLoad_Click(object sender, EventArgs e)
        {
            try
            {
                OpenFileDialog Open = new OpenFileDialog();
                Open.Filter = "Image Files(*.jpg; *.jpeg; *.gif; *.bmp)|*.jpg; *.jpeg; *.gif; *.bmp";
                if (Open.ShowDialog() == DialogResult.OK)
                {
                 Bitmap b = new Bitmap(Open.FileName);
                 pictureScene.Image = b;
                 GUI.SetScenePicture = b;
                  for (int i = 1; i <= (b.Width-1); i++)
                  {
                      for (int j = 1; j <= ( b.Height-1); j++)
                      {
                          if (b.GetPixel(i, j).ToArgb() == Scene.StartPointColor.ToArgb()) ProjectScene.Start=new Point(i,j);
                          if (b.GetPixel(i, j).ToArgb() == Scene.GoalPointColor.ToArgb()) ProjectScene.Goal = new Point(i, j);
                       }
                  }
                }
          }
            catch (Exception)
            {
                throw new ApplicationException("Failed loading scene");
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
             try
            {
                SaveFileDialog Save = new SaveFileDialog();
                
                Save.Filter = "Image Files(*.jpg; *.jpeg; *.gif; *.bmp)|*.jpg; *.jpeg; *.gif; *.bmp";
                if (Save.ShowDialog() == DialogResult.OK)
                {
                    pictureScene.Image.Save(Save.FileName);
                }
            }
            catch (Exception)
            {
                throw new ApplicationException("Failed loading scene");
            }
        }
        #endregion
        private void button1_Click(object sender, EventArgs e)
        {
            ProjectScene.ShowStates = cbShowStates.Checked;
            Stopwatch StopWatch1 = new Stopwatch();
            StopWatch1.Start();
          ProjectScene.GridBmpNoPath = GUI.GetScenePicture;
          if (cbAlgoritms.SelectedIndex == 0) ProjectScene.UseAStar(lblLenghtofPath, lblNumberOfStates, lblNumberOfNewStates);
         // if (cbAlgoritms.SelectedIndex == 1) ProjectScene.UseDStar(lblLenghtofPath, lblNumberOfStates, lblNumberOfNewStates); ;
          if (cbAlgoritms.SelectedIndex == 1) ProjectScene.UseDLite(lblLenghtofPath, lblNumberOfStates, lblNumberOfNewStates); ;
          if (cbAlgoritms.SelectedIndex == 2) ProjectScene.UseAnytime(lblLenghtofPath, lblNumberOfStates, lblNumberOfNewStates); ;
          if (cbAlgoritms.SelectedIndex == 3) ProjectScene.UseADA(lblLenghtofPath, lblNumberOfStates, lblNumberOfNewStates); ;
          if (cbAlgoritms.SelectedIndex == 4) ProjectScene.UseLPA(lblLenghtofPath, lblNumberOfStates, lblNumberOfNewStates); ;
            pictureScene.Image = ProjectScene.GridBmpWithPath;
            StopWatch1.Stop();
            lblTime.Text = String.Format("{0}",StopWatch1.Elapsed );

        }

        private void pictureScene_Click(object sender, EventArgs e)
        {
            Point ClickPoint = pictureScene.PointToClient(Cursor.Position);
 
            if(radioParameters.Checked == true) 
            {
                #region Parameters
                Bitmap b = (Bitmap)pictureScene.Image;               
                if (radioStart.Checked == true)
                {
                    if (ProjectScene.Start != new Point()) { GUIPaint.PaintMark(b, ProjectScene.Start, Scene.EraserColor, Scene.EraserColor); }
                    ProjectScene.Start = ClickPoint;
                    GUIPaint.PaintMark(b, ProjectScene.Start, Scene.StartPointColor, Scene.StartMarkColor);
                }
                else if (radioGoal.Checked == true)
                {
                    if (ProjectScene.Goal != new Point()) { GUIPaint.PaintMark(b, ProjectScene.Goal, Scene.EraserColor, Scene.EraserColor); }
                    ProjectScene.Goal = ClickPoint;
                    GUIPaint.PaintMark(b, ProjectScene.Goal, Scene.GoalPointColor, Scene.GoalMarkColor);
                }
                pictureScene.Image = (Image)b;
                #endregion

            }

        }

        private void radioObstructions_MouseClick(object sender, MouseEventArgs e)
        {
            pictureScene.MouseDown += new MouseEventHandler(GUI.Painting_OnMouseDown);
            pictureScene.MouseMove += new MouseEventHandler(GUI.Painting_OnMouseMove);
            pictureScene.MouseUp += new MouseEventHandler(GUI.Painting_OnMouseUp);
        }

        private void radioParameters_MouseClick(object sender, MouseEventArgs e)
        {
            pictureScene.MouseDown += null;
            pictureScene.MouseMove += null;
            pictureScene.MouseUp += null;
        }


        private void ExitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void trackBar_width_Scroll(object sender, EventArgs e)
        {
            toolTip1.SetToolTip(trackBar_width, trackBar_width.Value.ToString());
        }

        private void trackBar_high_Scroll(object sender, EventArgs e)
        {
            toolTip1.SetToolTip(trackBar_high, trackBar_high.Value.ToString());
        }

        private void ToolStripMenuItem_Restart_Click(object sender, EventArgs e)
        {
            ProjectScene = new Scene();
            restart();
        }




        void restart()
        {
            GUI = new GUIPaint(this, radioLine, radioRectangle, radioPolygon, radioPen, radioEraser, ProjectScene.GridBmpNoPath);
            pictureScene.Image = (Image)(new Bitmap(ProjectScene.GetGridSize.X, ProjectScene.GetGridSize.Y));
            pictureScene = GUIPaint.CreateFrame(pictureScene);  
        }

        void ResizeRestart(int width, int height)
        {
            ProjectScene = new Scene();
            ProjectScene.SetGridSize(width, height);
            pictureScene.Width = width;
            pictureScene.Height = height;
            restart();
        }

        #region ResizeMenu
        
        private void btanSetScene_Click(object sender, EventArgs e)
        {
            ResizeRestart(trackBar_width.Value, trackBar_high.Value);
        }

        private void x300ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ResizeRestart(300, 300);
        }

        private void x100ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ResizeRestart(100, 100);
        }

        private void x200ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ResizeRestart(200, 200);
        }

        private void x500ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ResizeRestart(500, 500);
        }

        private void x700ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ResizeRestart(700, 700);
        }

        private void x400ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ResizeRestart(400, 400);
        }

        private void x600ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ResizeRestart(600, 600);
        }
        #endregion

        private void btnCoordinates_Click(object sender, EventArgs e)
        {
            StatesToCoordinate.ConvertToCoordinates(ProjectScene.Goal, ProjectScene.LastPathOfPoints);
        }



    }
        
    }




