﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Drawing;
using System.Windows.Forms;
using System.Text;

namespace SimulacniProstredi.GUI
{
   public class GUIPaint
    {
        
        Rectangle SelectRect = new Rectangle();
        Point ps = new Point();
        Point pe = new Point();
        public List<Point> ListOfPoints = new List<Point>();
  
        Form ThisForm;
        RadioButton radioLine, radioRectangle, radioPolygon, radioPen, radioEraser;
        bool shouldPaint = false;
        bool shouldErase = false;
        Bitmap ScenePictureOnly;
        
                public Bitmap  GetScenePicture
        { get { return ScenePictureOnly; } }
                public Bitmap SetScenePicture
                { set { ScenePictureOnly = value ; } }


                public GUIPaint(Form inForm, RadioButton inradioLine, RadioButton inradioRectangle, RadioButton inradioPolygon, RadioButton inradioPen, RadioButton inradioEraser, Bitmap inScenePicture)
        {
            ThisForm = inForm;
            radioLine = inradioLine;
            radioRectangle = inradioRectangle;
            radioPolygon = inradioPolygon;
            radioPen = inradioPen;
            radioEraser = inradioEraser;
            ScenePictureOnly = inScenePicture;
        }
        
        public static PictureBox CreateFrame (PictureBox  inPictureBox)
        {
            PictureBox FramedPictureBox = inPictureBox;
            Graphics g = Graphics.FromImage(FramedPictureBox.Image);
             Point[] PointsOfFrame =
             {
                 new Point(0,0),
                 new Point(FramedPictureBox.Width, 0),
                 new Point(FramedPictureBox.Width ,  FramedPictureBox.Height ),
                 new Point(0, FramedPictureBox.Height)
             };
             
            g.DrawPolygon(new Pen(Sceny.Scene.ObstacleColor,4), PointsOfFrame);
            return FramedPictureBox;
        }
        public static Bitmap PaintMark(Bitmap inBitman, Point inPoint, Color PointColor, Color MarkColor)
        {
            Bitmap b = inBitman;
                        for (int i = -1; i <= 1; i++)
            {
                for (int j = -1; j <= 1; j++) b.SetPixel(inPoint.X+i, inPoint.Y+j, MarkColor);
            }
            b.SetPixel(inPoint.X,inPoint.Y,PointColor);
            return b;
        }

        public void Painting_OnMouseDown(Object sender, MouseEventArgs e)
        {

         PictureBox  ThisPictureBox = (PictureBox)sender;
            SelectRect.Width = 0;
            SelectRect.Height = 0;
            SelectRect.X = e.X;
            SelectRect.Y = e.Y;

            ps.X = e.X;
            ps.Y = e.Y;
            pe = ps;
            if (e.Button == MouseButtons.Left)
            {
                if (radioPolygon.Checked) { ListOfPoints.Add(new Point(e.X, e.Y));
               
                Graphics g = Graphics.FromImage(this.ScenePictureOnly);
                g.FillEllipse(new SolidBrush(Sceny.Scene.ObstacleColor), e.X, e.Y, 2, 2);
                g.Dispose();
                }
                if (radioPen.Checked) { shouldPaint = true; }
                if (radioEraser.Checked) { shouldErase = true; }
            }
            if (e.Button == MouseButtons.Right)
            {
                Graphics g = Graphics.FromImage(ThisPictureBox.Image);
                Pen p = new Pen(Sceny.Scene.ObstacleColor, 4);
                int PocetPolozek = ListOfPoints.Count;
                Point[] PolygonPoints = new Point[PocetPolozek];
                for (int i = 0; i < PocetPolozek; i = i + 1)
                                {
                                    PolygonPoints[i]=ListOfPoints[i];
                                }
               if (PocetPolozek >2) g.DrawPolygon(new Pen(Sceny.Scene.ObstacleColor, 4/*2*/), PolygonPoints);
               
                ListOfPoints.Clear();
            }

            DrawInPictureBox(ThisPictureBox);
        }



        public void Painting_OnMouseMove(Object sender, MouseEventArgs e)
        {
            PictureBox ThisPictureBox = (PictureBox)sender;

            Graphics g = Graphics.FromImage(this.ScenePictureOnly);
            if (shouldPaint)
            {
                g.FillEllipse(new SolidBrush(Sceny.Scene.ObstacleColor), e.X, e.Y, 4, 4);
            }
            if (shouldErase)
            {
                g.FillEllipse(new SolidBrush(Sceny.Scene.EraserColor), e.X, e.Y, 5, 5);    
            }
            g.Dispose();
            if (e.Button == MouseButtons.Left)
            {

                if (radioLine.Checked)
                {
                    ControlPaint.DrawReversibleLine(ThisPictureBox.PointToScreen(ps), ThisPictureBox.PointToScreen(pe), Color.Black);
                    pe = new Point(e.X, e.Y);
                    ControlPaint.DrawReversibleLine(ThisPictureBox.PointToScreen(ps), ThisPictureBox.PointToScreen(pe), Color.Black);
                }
                else if (radioRectangle.Checked)
                {
                    ControlPaint.DrawReversibleFrame(ThisPictureBox.RectangleToScreen(SelectRect), Color.Black, FrameStyle.Dashed);
                    SelectRect.Width = e.X - SelectRect.X;
                    SelectRect.Height = e.Y - SelectRect.Y;
                    ControlPaint.DrawReversibleFrame(ThisPictureBox.RectangleToScreen(SelectRect), Color.Black, FrameStyle.Dashed);
                }
            }

            DrawInPictureBox(ThisPictureBox);
        }


        public void Painting_OnMouseUp(Object sender, MouseEventArgs e)
        {
            shouldPaint = false;
            shouldErase = false;
         PictureBox ThisPictureBox = (PictureBox)sender;

          Graphics g = Graphics.FromImage(this.ScenePictureOnly);
            Pen p = new Pen(Sceny.Scene.ObstacleColor, 4);
            if (radioLine.Checked)
            {
                ControlPaint.DrawReversibleLine(ThisPictureBox.PointToScreen(ps), ThisPictureBox.PointToScreen(pe), Color.Black);
                g.DrawLine(p, ps, pe);
            }
            else if (radioRectangle.Checked)
            {
                ControlPaint.DrawReversibleFrame(ThisPictureBox.RectangleToScreen(SelectRect), Color.Black, FrameStyle.Dashed);
                g.DrawRectangle(p, SelectRect);
            }

            g.Dispose();

            DrawInPictureBox(ThisPictureBox);
        }
       void DrawInPictureBox(PictureBox ThisPictureBox)
       {
           Graphics g = Graphics.FromImage(ThisPictureBox.Image);
           g.DrawImage(ScenePictureOnly , new Point(0, 0));
           ThisPictureBox.Image = ThisPictureBox.Image ;

       }

    }

    }
