﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SimulacniProstredi
{
   public class Edge<inDataV, inDataE> : IEquatable<Edge<inDataV, inDataE>>, IComparable<Edge <inDataV, inDataE>>
        where inDataV : IEquatable<inDataV>, IComparable<inDataV>
        where inDataE : IEquatable<inDataE>, IComparable<inDataE>
    {
        int id;
        public int ID
        {
            get { return id; }
        }
        private  Vertex<inDataV, inDataE> IntoVertex;
        public Vertex<inDataV, inDataE> GetIntoVertex
        { get { return IntoVertex; } }
        private Vertex<inDataV, inDataE> OutVertex;
        public Vertex<inDataV, inDataE> GetOutVertex
        { get { return OutVertex; } }
        public inDataE EdgeData;
        static int MaxEdgeId = 0;

        int GetIdHrany()
        {
            MaxEdgeId = MaxEdgeId + 1;
            return MaxEdgeId;
        }

        public Edge()
        { this.id = GetIdHrany(); }

        public Edge(inDataE inEdgeData, Vertex<inDataV, inDataE> inOutVertex, Vertex<inDataV, inDataE> inIntoVertex) : this()
        {
            this.EdgeData = inEdgeData;
            this.IntoVertex = inIntoVertex;
            this.OutVertex = inOutVertex;
            this.GetIntoVertex.GetInputEdges.Add(this);
            this.GetOutVertex.GetOutputEdges.Add(this);

        }

       

        public void RemoveEdge()
        {
            this.OutVertex = null;
            this.IntoVertex=null;
        }


        #region IComparable<Hrana<vdataU,vdataH>> Members

        public int CompareTo(Edge<inDataV, inDataE> other)
        {
            return (id - other.ID);
        }

        #endregion

        #region IEquatable<Hrana<vdataU,vdataH>> Members

        public bool Equals(Edge<inDataV, inDataE> other)
        {
            if (this.id == other.id) { return true; }
            else { return false; }; ;
        }

        #endregion

        public override string ToString()
        {
            //return base.ToString();
            string description;
            description = String.Format("Id: {0}, {1}", id, EdgeData);
            return description;
        }
    } 
}
