﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SimulacniProstredi.Grafy
{
    class VertexData_State_ADA : IEquatable<VertexData_State_ADA>, IComparable<VertexData_State_ADA>
    {
        double x;
        double y;
        int h;
        VertexData_State_ADA Goal;
        Vertex<VertexData_State_ADA, EdgeData_Heuristic> bp = null;
        int v = int.MaxValue / 3;
        public double X
        { get { return this.x; } }
        public double Y
        { get { return this.y; } }
        int g = int.MaxValue / 3;
        public int Getg { get { return g; } }
        public int Setg { set { g = value; } }
        public int Geth { get { return h; } }
        public int Getv
        { get { return v; } }
        public int Setv
        { set { v = value; } }
        int[] key = new int[2];
        public int[] GetKey
        { get { return key ; } }
        public int[] SetKey
        { set { key = value; } }
        public Vertex<VertexData_State_ADA, EdgeData_Heuristic> GetBp
        { get { return bp; } }
        public Vertex<VertexData_State_ADA, EdgeData_Heuristic> SetBp
        { set { bp = value; } }

        public VertexData_State_ADA(double inX, double inY,VertexData_State_ADA inGoal)
        {
            x = inX;
            y = inY;
            Goal = inGoal;
            h = Convert.ToInt32(3 * Math.Sqrt(Math.Pow(this.x - Goal.x, 2) + Math.Pow(this.y - Goal.y, 2)));
        }
        public VertexData_State_ADA(double inX, double inY)
        {
            x = inX;
            y = inY;
           
        }
        public List<VertexData_State_ADA> Expand()
        {
            List<VertexData_State_ADA> ExpandList = new List<VertexData_State_ADA>();
           
            for (int i = -1; i <= 1; i++)
            {
                for (int j = -1; j <= 1; j++)
                {
                    if (!((i == 0) & (j == 0))) ExpandList.Add(new VertexData_State_ADA(this.x + i, this.y + j, /*this.g,*/ this.Goal));
                }
            }
            return ExpandList;
        }




        #region IComparable<VertexData_State> Members

        int IComparable<VertexData_State_ADA>.CompareTo(VertexData_State_ADA other)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region IEquatable<VertexData_State> Members

        public bool Equals(VertexData_State_ADA other)
        {
            if ((this.x == other.x) & (this.y == other.y))
            { return true; }
            else { return false; }
        }
        #endregion
    }
}
