﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SimulacniProstredi.Grafy
{
    public class VertexData_State_Astar : IEquatable<VertexData_State_Astar>, IComparable<VertexData_State_Astar>
    {
        double x;
        double y;
        public double X
        { get { return this.x; } }
        public double Y
        { get { return this.y; } }
       //
       int g=0;
        int h;
        VertexData_State_Astar Goal;
        public int Cost
        { get { return h + g; } }
        //
        public VertexData_State_Astar(double inX, double inY, VertexData_State_Astar inGoal)
        {
            x = inX;
            y = inY;
            Goal = inGoal;
        }
        public VertexData_State_Astar(double inX, double inY,int inParrentsG,VertexData_State_Astar inGoal)
        {
            x = inX;
            y = inY;
            g = inParrentsG + 1;
            Goal = inGoal;
            h = Convert.ToInt32(3 * Math.Sqrt(Math.Pow(this.x - Goal.x, 2) + Math.Pow(this.y - Goal.y,2)));//3 je koeficient, kdyžtak změnit
     
        }

        public List<VertexData_State_Astar> Expand()
        {
            List<VertexData_State_Astar> ExpandList = new List<VertexData_State_Astar>();

            for (int i = -1; i <= 1; i++)
            {
                for (int j = -1; j <= 1; j++)
                {
                    ExpandList.Add(new VertexData_State_Astar(this.x +i, this.y + j, this.g, this.Goal));
                }
            }
            return ExpandList;
        }

        #region IComparable<VertexData_State> Members

        int IComparable<VertexData_State_Astar>.CompareTo(VertexData_State_Astar other)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region IEquatable<VertexData_State> Members

     public bool Equals(VertexData_State_Astar other)
        {
            if ((this.x == other.x) & (this.y == other.y))
            { return true; }
            else { return false; }
        }
   
        #endregion
    }
}
