﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SimulacniProstredi.Grafy
{
    public class VertexData_State_Dstar : IEquatable<VertexData_State_Dstar>, IComparable<VertexData_State_Dstar>
    {
        double x;
        double y;
        public double X
        { get { return this.x; } }
        public double Y
        { get { return this.y; } }

        int h;
        int[] cost = new int [2];
        VertexData_State_Dstar Goal;
       Vertex<VertexData_State_Dstar, EdgeData_Heuristic> Backpointer;
      public  Vertex<VertexData_State_Dstar, EdgeData_Heuristic> SetBackpointer{set {Backpointer = value ;}}
      public   Vertex<VertexData_State_Dstar, EdgeData_Heuristic> GetBackpointer{get {return Backpointer ;}}
      Vertex<VertexData_State_Dstar, EdgeData_Heuristic> StateOfInsertion;
      public Vertex<VertexData_State_Dstar, EdgeData_Heuristic> SetStateOfInsertion { set { StateOfInsertion = value; } }
      public Vertex<VertexData_State_Dstar, EdgeData_Heuristic> GetStateOfInsertion { get { return StateOfInsertion; } }
        public int GetH
      { get {  return h; } }
       public int SetH
        { set { h = value; } }
        public int[] CostVector
        { get { cost[1] = Convert.ToInt32(1 * Math.Sqrt(Math.Pow(this.x - Goal.x, 2) + Math.Pow(this.y - Goal.y, 2))); return cost; } }
        public int Cost
        { get { return h; } }
        public  int key;
      public int f;
      public int fB;
      int[] bias;
      public int[] SetBias { set { bias = value; } }
      public int[] GetBias { get { return bias; } }
        byte tag = 0;  // 0 = new ; 1 = Open ; 2= Closed
        public byte SetTag { set { tag = value; } }
        public byte GetTag { get { return tag; } }
           public int Computeg(VertexData_State_Dstar AnotherVertexData)
        {
           
            if (bias[0] >= bias[1])
            { return Convert.ToInt32(1 * (Math.Sqrt(2) * bias[1] + bias[0] - bias[1])); }
            else
            { return Convert.ToInt32(1 * (Math.Sqrt(2) * bias[0] + bias[1] - bias[0])); }

        }
        public   void Computeh()
           { h = Convert.ToInt32(3 * Math.Sqrt(Math.Pow(this.x - Goal.x, 2) + Math.Pow(this.y - Goal.y, 2))); }

           void ComputeBias()
           {  int[] d = new int[2];
               d[0] = Math.Abs(Convert.ToInt32(x - y));
               d[1] = Math.Abs(Convert.ToInt32(StateOfInsertion.VertexData.X - StateOfInsertion.VertexData.Y)); 
           }
    
        public VertexData_State_Dstar(double inX, double inY, VertexData_State_Dstar inGoal)
        {
            x = inX;
            y = inY;
            Goal = inGoal;
        }
        public VertexData_State_Dstar(double inX, double inY )
        {
            x = inX;
            y = inY;
         }

        public List<VertexData_State_Dstar> Expand()
        {
            List<VertexData_State_Dstar> ExpandList = new List<VertexData_State_Dstar>();

            for (int i = -1; i <= 1; i++)
            {
                for (int j = -1; j <= 1; j++)
                {
                 if (!((i==0)&(j==0)))   ExpandList.Add(new VertexData_State_Dstar(this.x + i, this.y + j,this.Goal));
                }
            }
            return ExpandList;
        }

        #region IComparable<VertexData_State> Members

        int IComparable<VertexData_State_Dstar>.CompareTo(VertexData_State_Dstar other)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region IEquatable<VertexData_State> Members

        public bool Equals(VertexData_State_Dstar other)
        {
            if ((this.x == other.x) & (this.y == other.y))
            { return true; }
            else { return false; }
        }

        #endregion
    }
}
