﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Text;
using SimulacniProstredi.Algoritmy;
using System.Drawing;
using System.Drawing.Drawing2D;


namespace SimulacniProstredi.Sceny
{
    public class Scene
    {
      //  public List<Obstacle> ListOfObstacles = new List<Obstacle>();
        public bool ShowStates = false;
        public Point Start;
        public Point Goal;
       Point GridSize = new Point(700, 700);
        public Point MaxMapSize;
       public Point GetGridSize {get {return GridSize ;}}
        public Bitmap GridBmpWithPath = new Bitmap(700, 700, System.Drawing.Imaging.PixelFormat.Format32bppArgb); //new Bitmap(700, 700, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
        public Bitmap GridBmpNoPath = new Bitmap(700, 700, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
        public Point[,] PointsOfHexagonalLattice;
      public int PointsOfLatticeDistance = 1;
         int PointsOfLatticeDistanceY;
       static public Color ObstacleColor = Color.Blue;
       static public Color PathColor = Color.Red;
       static public Color StartPointColor = Color.DarkKhaki;
       static public Color GoalPointColor = Color.BurlyWood;
       static public Color StartMarkColor = Color.RosyBrown;
       static public Color GoalMarkColor = Color.Gold;
       static public Color SearchedColor = Color.YellowGreen;
       static public Color NewlySearchedColor = Color.Aqua;
        static public Color EraserColor = SystemColors.Window  ;
        Boolean usedLPA, usedDLite, usedADA = false;
        LPAStar LPAStarSearch;
        DLite DLiteSearch;
        ADA ADASearch;
        public List<Point> LastPathOfPoints;

        public void SetGridSize(int inX, int inY)
        {
          GridSize = new Point(inX, inY);
            GridBmpWithPath = new Bitmap(inX, inY, System.Drawing.Imaging.PixelFormat.Format32bppArgb); //new Bitmap(700, 700, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
        GridBmpNoPath = new Bitmap(inX, inY, System.Drawing.Imaging.PixelFormat.Format32bppArgb);

        }
     void CreateLattice()
       {
            PointsOfLatticeDistanceY = Convert.ToInt32(Math.Sqrt(Convert.ToDouble(3 * Math.Pow(Convert.ToDouble(PointsOfLatticeDistance), 2) / 4)));
            MaxMapSize = new Point((GridBmpNoPath.Width / PointsOfLatticeDistance), (GridBmpNoPath.Height / PointsOfLatticeDistanceY));
            PointsOfHexagonalLattice = new Point[MaxMapSize.X, MaxMapSize.Y];
          


            for (int i = 0; i < (GridBmpNoPath.Width / PointsOfLatticeDistance); i++)
           {
               for (int j = 0; j < (GridBmpNoPath.Height / PointsOfLatticeDistanceY); j++)
               {
                   PointsOfHexagonalLattice[i, j].X = i;
                   PointsOfHexagonalLattice[i, j].Y = j ;
               }
           }
       }
     public bool IsWalkable(double inPoint1x, double inPoint1y, double inPoint2x, double inPoint2y)
       {
           double difX = inPoint2x - inPoint1x;
           double difY = inPoint2y - inPoint1y;
        


           if(difX > 0)
           {
             if(difY > 0)
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) if (GridBmpNoPath.GetPixel(Convert.ToInt32(inPoint1x + i), Convert.ToInt32(inPoint1y + i)).ToArgb() == ObstacleColor.ToArgb()) return false;
             }
             else if (difY <0)
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) if (GridBmpNoPath.GetPixel(Convert.ToInt32(inPoint1x + i), Convert.ToInt32(inPoint1y - i)).ToArgb() == ObstacleColor.ToArgb()) return false;
             }
             else
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) if (GridBmpNoPath.GetPixel(Convert.ToInt32(inPoint1x + i), Convert.ToInt32(inPoint1y)).ToArgb() == ObstacleColor.ToArgb()) return false;
             }
           }
           else if (difX <0)
           {
              if(difY > 0)
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) if (GridBmpNoPath.GetPixel(Convert.ToInt32(inPoint1x - i), Convert.ToInt32(inPoint1y + i)).ToArgb() == ObstacleColor.ToArgb()) return false;
             }
             else if (difY <0)
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) if (GridBmpNoPath.GetPixel(Convert.ToInt32(inPoint1x - i), Convert.ToInt32(inPoint1y - i)).ToArgb() == ObstacleColor.ToArgb()) return false;
             }
             else
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) if (GridBmpNoPath.GetPixel(Convert.ToInt32(inPoint1x - i), Convert.ToInt32(inPoint1y)).ToArgb() == ObstacleColor.ToArgb()) return false;
             }
           }
           else if (difX == 0)
           {
               if (difY > 0)
               {
                   for (int i = 0; i <= Math.Abs(difY); i++) if (GridBmpNoPath.GetPixel(Convert.ToInt32(inPoint1x), Convert.ToInt32(inPoint1y + i)).ToArgb() == ObstacleColor.ToArgb()) return false;
               }
               else if (difY < 0)
               {
                   for (int i = 0; i <= Math.Abs(difY); i++) if (GridBmpNoPath.GetPixel(Convert.ToInt32(inPoint1x), Convert.ToInt32(inPoint1y - i)).ToArgb() == ObstacleColor.ToArgb()) return false;
               }
           }
         
           //da se to vyresit pres porovnani(<,>,=) x a y souradnic pocatecniho a konecneho bodu -> aomoci nekolika ifu urcit smer

           return true ;
       }


     void PaintIt(double inPoint1x, double inPoint1y, double inPoint2x, double inPoint2y,Color inColor)
     {
         double difX = inPoint2x - inPoint1x;
         double difY = inPoint2y - inPoint1y;

         if (difX > 0)
         {
             if (difY > 0)
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) GridBmpWithPath.SetPixel(Convert.ToInt32(inPoint1x + i), Convert.ToInt32(inPoint1y + i),inColor);
             }
             else if (difY < 0)
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) GridBmpWithPath.SetPixel(Convert.ToInt32(inPoint1x + i), Convert.ToInt32(inPoint1y - i),inColor);
             }
             else
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) GridBmpWithPath.SetPixel(Convert.ToInt32(inPoint1x + i), Convert.ToInt32(inPoint1y), inColor);
             }
         }
         else if (difX < 0)
         {
             if (difY > 0)
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) GridBmpWithPath.SetPixel(Convert.ToInt32(inPoint1x - i), Convert.ToInt32(inPoint1y + i), inColor);
             }
             else if (difY < 0)
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) GridBmpWithPath.SetPixel(Convert.ToInt32(inPoint1x - i), Convert.ToInt32(inPoint1y - i), inColor);
             }
             else
             {
                 for (int i = 0; i <= Math.Abs(difX); i++) GridBmpWithPath.SetPixel(Convert.ToInt32(inPoint1x - i), Convert.ToInt32(inPoint1y), inColor);
             }
         }
         if (difX == 0)
         {
             if (difY > 0)
             {
                 for (int i = 0; i <= Math.Abs(difY); i++) GridBmpWithPath.SetPixel(Convert.ToInt32(inPoint1x), Convert.ToInt32(inPoint1y + i), inColor);
             }
             else if (difY < 0)
             {
                 for (int i = 0; i <= Math.Abs(difY); i++) GridBmpWithPath.SetPixel(Convert.ToInt32(inPoint1x), Convert.ToInt32(inPoint1y - i), inColor);
             }
         }

         //da se to vyresit pres porovnani(<,>,=) x a y souradnic pocatecniho a konecneho bodu -> aomoci nekolika ifu urcit smer

         
     }
         public Point DetectPoint(Point inSearchedPoint)
         {
           Point ClosePoint = new Point((inSearchedPoint.X - PointsOfLatticeDistance / 2) / PointsOfLatticeDistance, (inSearchedPoint.Y - PointsOfLatticeDistanceY / 2) / PointsOfLatticeDistanceY);
           return ClosePoint;
       }

        public  Boolean CheckStartParameters()
    {
            if ((Start != null) & (Goal != null)) 
            {return true;}
            else {return false;}
    }


        public void UseAStar(Label lblLenghtofPath, Label lblNumberOfStates, Label lblNumberOfNewStates)
        {
            if (CheckStartParameters() == true)
            {
              this.GridBmpWithPath = this.GridBmpNoPath;
                CreateLattice();
                AStar AStarSearch = new AStar(this);
                List<Point> PathofPoints = AStarSearch.ReturnPoints();
                List<Point> SearchedStates = AStarSearch.ReturnSearchedNodes();//smaz me   
                lblLenghtofPath.Text = String.Format("{0}", PathofPoints.Count);
                lblNumberOfStates.Text = String.Format("{0}", SearchedStates.Count);
                lblNumberOfNewStates.Text = String.Format("{0}", SearchedStates.Count);
                if (ShowStates == true)
                {
                    for (int i = 0; i < (SearchedStates.Count - 1); i++)
                    {
                        if (GridBmpNoPath.GetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y), NewlySearchedColor);
                    }
                }
                for (int i = 0; i <(PathofPoints.Count -2); i++)
                {
                    PaintIt(PathofPoints[i].X, PathofPoints[i].Y, PathofPoints[i+1].X, PathofPoints[i+1].Y,PathColor);
                }
                LastPathOfPoints = PathofPoints;
            }
        }
        public void UseDStar(Label lblLenghtofPath, Label lblNumberOfStates, Label lblNumberOfNewStates)
        {
            if (CheckStartParameters() == true)
            {

                CreateLattice();
                DStar DStarSearch = new DStar(this);
                DStarSearch.MoveRobot();
                List<Point> PathofPoints = DStarSearch.ReturnPoints();
                List<Point> SearchedStates = DStarSearch.ReturnSearchedNodes();//smaz me   
                List<Point> NewlySearchedStates = DStarSearch.ReturnNewlySearchedNodes();
                lblNumberOfNewStates.Text = String.Format("{0}", NewlySearchedStates.Count);
                lblLenghtofPath.Text = String.Format("{0}", PathofPoints.Count);
                lblNumberOfStates.Text = String.Format("{0}", SearchedStates.Count);
                if (ShowStates == true)
                {
                    for (int i = 0; i < (SearchedStates.Count - 1); i++)
                    {
                        if (GridBmpNoPath.GetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y), SearchedColor);
                    }
                    for (int i = 0; i < (NewlySearchedStates.Count - 1); i++)
                    {
                        if (GridBmpNoPath.GetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y), NewlySearchedColor);
                    }
                }
                for (int i = 0; i < (PathofPoints.Count - 2); i++)
                {
                    PaintIt(PathofPoints[i].X, PathofPoints[i].Y, PathofPoints[i + 1].X, PathofPoints[i + 1].Y, PathColor);
                }
                LastPathOfPoints = PathofPoints;
            }
        }
        public void UseDLite(Label lblLenghtofPath, Label lblNumberOfStates, Label lblNumberOfNewStates)
        {
            if (CheckStartParameters() == true)
            {
                this.GridBmpWithPath = this.GridBmpNoPath;
                List<Point> PathofPoints;
                if (!usedDLite)
                {
                    CreateLattice();
                    DLiteSearch = new DLite(this);
                    DLiteSearch.UseDLite_FirstTime();
                    usedDLite = true;
    
                }
                else
                {
                   
                    DLiteSearch.UseDLite();
                   
                }

                PathofPoints = DLiteSearch.ReturnPoints();
                List<Point> SearchedStates = DLiteSearch.ReturnSearchedNodes();//smaz me   
                List<Point> NewlySearchedStates = DLiteSearch.ReturnNewlySearchedNodes();
                lblNumberOfNewStates.Text = String.Format("{0}", NewlySearchedStates.Count);
                lblLenghtofPath.Text = String.Format("{0}", PathofPoints.Count);
                lblNumberOfStates.Text = String.Format("{0}", SearchedStates.Count);
                if (ShowStates == true)
                {
                    for (int i = 0; i < (SearchedStates.Count - 1); i++)
                    {
                        if (GridBmpNoPath.GetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y), SearchedColor);
                    }
                    for (int i = 0; i < (NewlySearchedStates.Count - 1); i++)
                    {
                        if (GridBmpNoPath.GetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y), NewlySearchedColor);
                    }
                }
                for (int i = 0; i < (PathofPoints.Count - 2); i++)
                {
                    PaintIt(PathofPoints[i].X, PathofPoints[i].Y, PathofPoints[i + 1].X, PathofPoints[i + 1].Y, PathColor);
                }
                LastPathOfPoints = PathofPoints;
            }
        }
        public void UseAnytime(Label lblLenghtofPath, Label lblNumberOfStates, Label lblNumberOfNewStates)
        {
            if (CheckStartParameters() == true)
            {
                this.GridBmpWithPath = this.GridBmpNoPath;
                CreateLattice();
                ARA ARASearch = new ARA(this);
                ARASearch.UseARA_FirstTime();
                List<Point> PathofPoints = ARASearch.ReturnPoints();
                List<Point> SearchedStates = ARASearch.ReturnSearchedNodes();//smaz me   
                lblNumberOfNewStates.Text = String.Format("{0}", SearchedStates.Count);
                lblLenghtofPath.Text = String.Format("{0}", PathofPoints.Count);
                lblNumberOfStates.Text = String.Format("{0}", SearchedStates.Count);
                if (ShowStates == true)
                {
                    for (int i = 0; i < (SearchedStates.Count - 1); i++)
                    {
                        if (GridBmpNoPath.GetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y), NewlySearchedColor);
                    }
                }
                for (int i = 0; i < (PathofPoints.Count - 2); i++)
                {
                    PaintIt(PathofPoints[i].X, PathofPoints[i].Y, PathofPoints[i + 1].X, PathofPoints[i + 1].Y, PathColor);
                }
                     while (ARASearch.Ended != true)
                      {
                          ARASearch.UseARA();
                           PathofPoints = ARASearch.ReturnPoints();
                          SearchedStates = ARASearch.ReturnSearchedNodes();//smaz me   
                          lblLenghtofPath.Text = String.Format("{0}", PathofPoints.Count);
                          lblNumberOfStates.Text = String.Format("{0}", SearchedStates.Count);
                          lblNumberOfNewStates.Text = String.Format("{0}", SearchedStates.Count);
                          if (ShowStates == true)
                          {
                              for (int i = 0; i < (SearchedStates.Count - 1); i++)
                              {
                                  if (GridBmpNoPath.GetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y), SearchedColor);
                              }
                          }
                          for (int i = 0; i < (PathofPoints.Count - 2); i++)
                          {
                              PaintIt(PathofPoints[i].X, PathofPoints[i].Y, PathofPoints[i + 1].X, PathofPoints[i + 1].Y, PathColor);
                          }
                          LastPathOfPoints = PathofPoints;
                      }
            }
        }
        public void UseADA(Label lblLenghtofPath, Label lblNumberOfStates, Label lblNumberOfNewStates)
        {
            if (CheckStartParameters() == true)
            {
                this.GridBmpWithPath = this.GridBmpNoPath;
                List<Point> PathofPoints;
                List<Point> SearchedStates;
                List<Point> NewlySearchedStates;
                if (!usedADA)
                {
                    CreateLattice();
                    ADASearch = new ADA(this);
                    ADASearch.UseADA_FirstTime();
                     PathofPoints = ADASearch.ReturnPoints();
                     SearchedStates = ADASearch.ReturnSearchedNodes();//smaz me   
                     NewlySearchedStates = ADASearch.ReturnNewlySearchedNodes();
                     lblNumberOfNewStates.Text = String.Format("{0}", NewlySearchedStates.Count);
                    lblLenghtofPath.Text = String.Format("{0}", PathofPoints.Count);
                    lblNumberOfStates.Text = String.Format("{0}", SearchedStates.Count);
                    if (ShowStates == true)
                    {
                        for (int i = 0; i < (SearchedStates.Count - 1); i++)
                        {
                            if (GridBmpNoPath.GetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y), SearchedColor);
                        }
                        for (int i = 0; i < (NewlySearchedStates.Count - 1); i++)
                        {
                            if (GridBmpNoPath.GetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y), NewlySearchedColor);
                        }
                    }
                    for (int i = 0; i < (PathofPoints.Count - 2); i++)
                    {
                        PaintIt(PathofPoints[i].X, PathofPoints[i].Y, PathofPoints[i + 1].X, PathofPoints[i + 1].Y, PathColor);
                    }
                    usedADA = true;
                }
                ADASearch.Ended = false;
                
                while (ADASearch.Ended != true)
                {
                    ADASearch.ADARestart = false;
                    List<Point> SS = ADASearch.ReturnSearchedNodes();
                    ADASearch.UseADA();
                    
                    if (ADASearch.ADARestart == true) {
                        
                        for (int i = 0; i < (SS.Count -1); i++)
                        {
                            if (GridBmpNoPath.GetPixel(Convert.ToInt32(SS[i].X), Convert.ToInt32(SS[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SS[i].X), Convert.ToInt32(SS[i].Y), SearchedColor);
                        }
                    }
                    PathofPoints = ADASearch.ReturnPoints();
                    SearchedStates = ADASearch.ReturnSearchedNodes();//smaz me   
                    NewlySearchedStates = ADASearch.ReturnNewlySearchedNodes();
                    lblNumberOfNewStates.Text = String.Format("{0}", NewlySearchedStates.Count);
                    lblLenghtofPath.Text = String.Format("{0}", PathofPoints.Count);
                    lblNumberOfStates.Text = String.Format("{0}", SearchedStates.Count);
                    if (ShowStates == true)
                    {
                        for (int i = 0; i < (SearchedStates.Count - 1); i++)
                        {
                            if (GridBmpNoPath.GetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y), SearchedColor);
                        }
                        for (int i = 0; i < (NewlySearchedStates.Count - 1); i++)
                        {
                            if (GridBmpNoPath.GetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y), NewlySearchedColor);
                        }
                    }
                    for (int i = 0; i < (PathofPoints.Count - 2); i++)
                    {
                        PaintIt(PathofPoints[i].X, PathofPoints[i].Y, PathofPoints[i + 1].X, PathofPoints[i + 1].Y, PathColor);
                    }
                    LastPathOfPoints = PathofPoints;
                }

                if (ADASearch.Ended) ADASearch.ClearCurrentNodesList();
            }
        }
        public void UseLPA(Label lblLenghtofPath, Label lblNumberOfStates, Label lblNumberOfNewStates)
        {
            if (CheckStartParameters() == true)
            {
                this.GridBmpWithPath = this.GridBmpNoPath;
                if (!usedLPA)
                {
                    CreateLattice();
                    LPAStarSearch = new LPAStar(this);
                    LPAStarSearch.UseLPA_FirstTime();
                    usedLPA = true;
                }
                else {

                    LPAStarSearch.UseLPA();
                }
                List<Point> PathofPoints = LPAStarSearch.ReturnPoints();
                List<Point> SearchedStates = LPAStarSearch.ReturnSearchedNodes();//smaz me
                List<Point> NewlySearchedStates = LPAStarSearch.ReturnNewlySearchedNodes();
                lblNumberOfNewStates.Text = String.Format("{0}", NewlySearchedStates.Count);
                lblLenghtofPath.Text = String.Format("{0}", PathofPoints.Count);
                lblNumberOfStates.Text = String.Format("{0}", SearchedStates.Count);
                if (ShowStates == true)
                {
                    for (int i = 0; i < (SearchedStates.Count - 1); i++)
                    {
                        if (GridBmpNoPath.GetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(SearchedStates[i].X), Convert.ToInt32(SearchedStates[i].Y), SearchedColor);
                    }
                    for (int i = 0; i < (NewlySearchedStates.Count - 1); i++)
                    {
                        if (GridBmpNoPath.GetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y)).ToArgb() != ObstacleColor.ToArgb()) GridBmpWithPath.SetPixel(Convert.ToInt32(NewlySearchedStates[i].X), Convert.ToInt32(NewlySearchedStates[i].Y), NewlySearchedColor);
                    }
                }
                for (int i = 0; i < (PathofPoints.Count - 2); i++)
                {
                    PaintIt(PathofPoints[i].X, PathofPoints[i].Y, PathofPoints[i + 1].X, PathofPoints[i + 1].Y,PathColor);
                }
                LastPathOfPoints = PathofPoints;
            }
        }

    }
}
