﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.IO;

namespace SimulacniProstredi.Sceny
{
    static class StatesToCoordinate
    {

        private static bool IsInList(Point point, List<Point> ListOfPoints)
        {
            foreach (Point p in ListOfPoints)
            {
                if (point.Equals(p)) { return true; }
            }
            return false;
        }

        static public void ConvertToCoordinates(Point Goal, List<Point> PathOfPoints)
        {
            List<Point> Coordinates = new List<Point>();
            if (PathOfPoints == null) MessageBox.Show("Neexistuje žádná cesta. Provedtě nejprve plánování cesty.");;
            if (PathOfPoints.Count == 0) MessageBox.Show("Neexistuje žádná cesta. Provedtě nejprve plánování cesty.");;
            int xdiff, ydiff, prevxdiff, prevydiff;
            prevxdiff = 0;
            prevydiff = 0;
            for (int i = 0; i < (PathOfPoints.Count - 2); i++)
            {
                xdiff = PathOfPoints[i + 1].X - PathOfPoints[i].X;
                ydiff = PathOfPoints[i + 1].Y - PathOfPoints[i].Y;
                if ((xdiff != prevxdiff) | (ydiff != prevydiff)) Coordinates.Add(PathOfPoints[i]);

                prevxdiff = xdiff;
                prevydiff = ydiff;
            }
            if (!IsInList(Goal, Coordinates)) Coordinates.Add(Goal);
            

                try
                {
                    Stream myStream;
                    SaveFileDialog Save = new SaveFileDialog();

                    Save.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
                    Save.FilterIndex = 1;
                    Save.RestoreDirectory = true;

                    if (Save.ShowDialog() == DialogResult.OK)
                    {

                        if ((myStream = Save.OpenFile()) != null)
                        {
                            
                            StreamWriter tw = new StreamWriter(myStream);


                            for (int i = 0; i < (Coordinates.Count - 1); i++)
                            {
                          
                                tw.WriteLine(String.Format("X: {0} Y: {1}", Convert.ToString(Coordinates[i].X), Convert.ToString(Coordinates[i].Y)));
                            }
                          
                            tw.Close();
                        }

                    }
                }
                catch (Exception)
                {
                    throw new ApplicationException("Failed loading scene");
                }


        }

    }

}